/////////////////////////////////////////////////////////////
//                                                         //
// Copyright 1994, 1995, 1996                              //
// MASTER INFORMATION SYSTEMS CORPORATION                  //
// MUSKOX Version 1.2					   //
// All Rights Reserved                                     //
//                                                         //
/////////////////////////////////////////////////////////////

#include <iostream.h>
#include <stdlib.h>
#include <string.h>

#include "generus.h"


long	Level = 0;


//#undef DEBUGGEN
//#undef DEBUGGENSTACK
#define DEBUGGEN
#define DEBUGGENSTACK

#define DEBUGEXPAND
#define CHUNK   16384

protoVisit  *freeStore;
protoVisit  *atEnd;
protoVisit  *currLoc;


lr1Tables *protoVisit::Lr1Tables = 0;
generator *protoVisit::Generator = 0;


///////////////////////
//This function generates up to 'number' sentences of length
//no more than 'len' tokens
///////////////////////
int   lr1Tables::Generate(register lex *l,
			  register long len,
			  register long number,
			  register ostream &f)
{
register ubrick from = StartState;
if ( !from )					// no start state specified
 return 0;
register generator *g = Generator;
if ( !g->StatesNumber )				// no generation specified
 return 0;
register ubrick *to = g->FindTransition(from, Start, this);
if ( !to )
 return 0;            				// no start symbol
if ( (to = g->FindTransition(*to, EndOfStream, this)) == NULL )
 return 0;                                     // corrupted automaton
return GenerateFromTo(l, from, *to, len, number, f);//do!
}


////////////////////////
//finds the edge which is marked by 'token'
// and ougoes from the state 'state'
////////////////////////
ubrick	*generator::FindTransition(register ubrick state,
				   register ubrick token,
				   register lr1Tables *l)
{
register ubrick *edges = Edges + GenShiftHash[state];
register ubrick *end = edges + *edges++ + 1;
while ( edges < end )                           // find token
 if ( l->DebugHash[*edges++]->Result == token )
   return --edges;                              // found
return 0;					// failure...
}


protoVisit stop(BRICKFFFF);		// &stop is returned to stop
						// advancement


/////////////////////////////////////////
//This function finds all the paths in the lr1 automaton
//leading from state 'from' to state 'to' of length no more than 'len'.
//After finding each next path, it calls initvisits::Expand()
//to perform expansion of nonterminals from the found path.
//It stops when the number of expanded sentences reaches 'number',
//or when all the paths will have been proccessed.
//'f' is the file to output expanded paths.
/////////////////////////////////////////
int   lr1Tables::GenerateFromTo(register lex *l,
			  register ubrick from,
			  register ubrick to,
			  register long len,
			  register long number,
			  register ostream &f)
{
freeStore = atEnd = currLoc = (protoVisit*) new char [CHUNK];
freeStore->next = 0;
register generator *g = Generator;       	// init static members of
protoVisit::Lr1Tables = this;			// protoVisit
protoVisit::Generator = g;
bounds b(len);					// bound for length
initVisits path(&b, to, g, l, this, f);         // the main structure
register protoVisit *current = path.GetVisit(from);
current->Flag |= F_hide;
register protoVisit *start = current;
path.Start = start;
path.PathCounter = (ubrick)number;
register protoVisit *next = current->Advance(&path);// first advancement
while ( path.PathCounter )                      // up to number sentences
{
 if ( !next )
   return 0; 		                        // some error...
 if ( next->State == to )			// reached the target
 {
   current->NextVisit = next;
   next->PrevVisit = current;
   if ( path.Expand(to) )			// expand via rules and print
      { freeAll(); return 1;}			// found #number sentences
   if ( next != path.TargetState )              // do not delete TargetState
      path.Delete(next);                        // from path - we may need it
   next = &stop;
 }
 if ( next == &stop )    			// can not advance...
 {
#  if defined(DEBUGGEN)
      path.PrintStack(current);
#  endif
   for ( ;; )					// go back and fork...
   {
      if ( (next = current->Fork(&path)) != &stop )// found the alternative...
	  break;
      if ( !(current->Flag&F_reached) )         // if target is not reached
      {						// prune this node
	  if ( path.Distance[current->State] )
	  {
	       register brick *r = path.Distance[current->State] + path.Target;
	       if ( r && (*r < path.Remains) )
	             *r = path.Remains;
	  }
      }
      else                                      // target was reached -
	  current->Flag &= ~F_reached;          // clear for further visits
      if ( !(current->Flag&F_single0) )         // not a single alpha : ;
      {
	  path.Remains += current->Delta();	// now backtrack
	  path.NonTerminals -= current->IsItNonTerminal();
      }
      next = current->PrevVisit;
      path.Delete(current);                     // do not need current node
      if ( !next )
	  return 0; 				// end of job
      current = next;				// go back one state
   }
 }
 else						// advance further
 {
   current = next;
#  if defined(DEBUGGEN)
      path.PrintWord(current);
#  endif
   next = current->Advance(&path);
 }
}
freeAll(); 
return 1; 					// found #number sentences
}


void	initVisits::PrintStack(register protoVisit *current)
{
*(Tables->Cerr) << "\n---Start Fork: ";
#if defined(DEBUGGENSTACK)
 register protoVisit *prev = current;
 do
   *(Tables->Cerr) << prev->State << ' ';
 while ( (prev = prev->PrevVisit) != NULL );
#endif
}


void	initVisits::PrintWord(register protoVisit *current)
{
if ( !(current->Flag & F_hide) )
 *(Tables->Cerr) << Tables->DebugHash[current->State]->Word << ' ';
else
 *(Tables->Cerr) << "... " << Tables->DebugHash[current->State]->Word << ' ';
}


initVisits::initVisits(register bounds *b, register ubrick to,
		       register generator *g, register lex *l,
		       register lr1Tables *t, ostream &f) : Io(f)
{
Generator = g;                        	// initiate basic things
Lex = l;
Tables = t;
Target = to;
TargetState = new protoVisit(to);
Remains = (brick)(b->Length);
NonTerminals = 0;

register ubrick n = Number = g->StatesNumber;
Visits = new visit[n];
Steps  = new protoVisit *[n];
Distance = new brick *[n];
while ( n-- )
 Visits[n].Clear(), Steps[n] = CreateVisit(n), Distance[n] = 0;

///////////////////////////
//For each rule array Delta contains number of nonterminals
//in the right part of the rule and minimum length of the string,
//dervible from this rule
///////////////////////////
n = (g->NonTerminalsCounter - 1)<<1;
register ubrick m = ( g->Rules[n] + (g->Rules[n + 1]<<1) ) >> 1;
Delta = new delta[m];		// m - number of rules

m = 0;
n = g->NonTerminalsCounter;
do
 DeltaCalc(m, g, t);		// fill in Delta elements for all rules
while ( ++m < n );		// of nonterminal 'm'.
}

initVisits::~initVisits()
{
	delete [] Visits;
	for (ubrick i=0; i<Number; i++) {
		delete [] Distance[i]; 
	}
	delete [] Steps;
	delete [] Distance;
	delete [] Delta;
}


//////////////////////////////////
//For nonterminal m calculates number of nonterminals in
//the right part of each rule with m in the left part.
//Does not take into account nonterminals with the
//only rule 'm : ;' - m will never appear in the generated sentence.
//We do not need it, because the parser will reduce
//such a rule automatically.
//Also calculates the minimal length of the derived string.
//////////////////////////////////
void	initVisits::DeltaCalc(register ubrick m, register generator *g,
			      register lr1Tables *t)
{
m <<= 1;
register ubrick *rules = g->Rules;
register delta *current = Delta + ((rules[m])>>1); // offset in Delta[]
register delta *current0 = current;
register ubrick counter = rules[m + 1];            // number of rules
register ubrick *rule = g->Lengths + rules[m];     // rules for this nonterm.
register ubrick max = g->MaxTerminal;		   // minimal nonterminal
while ( counter-- )				   // for all rules
{
 register ubrick *members = g->Members + *rule++;  // get to the right part
 register ubrick length = *rule++;		   // its length
 register ubrick derivedLength = 0;
 register brick nonTerminals = 0;
 while ( length-- )				   // for each member
 {
   register ubrick token = *members++;
   register brick dist = token - max;		   // is it nonterminal?
   if ( dist >= 0 )				   // yes... check for a
   {						   // rule 'm : ;'
      dist <<= 1;
      if ( !(rules[dist + 1] == 1 && !Generator->Lengths[rules[dist] + 1]) )
	  nonTerminals++;                          // not the case!
   }
   register ubrick newDerived = t->Find(token)->DerivedLength;
   if ( (newDerived != BRICKEFFF) && newDerived )
      derivedLength += newDerived;		   // token can be expanded
   else
      derivedLength += 1;                          // token cannot be expanded
 }
 register delta *current1 = current0;		   // sort new delta
 while ( current1 < current )
 {
   if ( current1->DerivedLength > derivedLength )  // insert here ?
      break;					   // yes...
   current1++;
 }
 register ubrick *rule2 = rule;			   // get
 length = *--rule2;                                //     the
 register ubrick offset = *--rule2;                //         rule
 register delta *current2 = current;
 while ( current2 > current1 )                     // shift rules and deltas
 {
   *current2 = current2[-1];			   // shift delta
   rule2[1] = rule2[-1];                           // shift
   rule2[0] = rule2[-2];                           //       rule
   rule2 -= 2;                                     // get previous
   current2--;                                     // rule and delta
 }
 *rule2++ = offset;				   // insert the
 *rule2 = length;				   //            last rule
 current1->DerivedLength = derivedLength;          // record delta
 current1->NonTerminals = nonTerminals;            // for the last rule
 current++;					   // get the next rule
}
}

reductions::reductions(register ubrick state, register generator *g)
{
Current = 0;
Forks = 0;
register ubrick transit = g->GenReduceHash[state];
switch ( transit >> BRICKHEADREDUCESHIFT )
{
 case B_ERROR_: 	Reductions2 = 0, Counter = 0;
			return;
 case B_REDUCE2MORE_:   Reductions2 = g->Reductions2 + (transit&~BRICKHEAD);
			Counter = *Reductions2++;
			return;
 default:		Reduction = transit, Counter = 1;
			return;
}
}


/////////////////////////
//Creates different kinds of visits
//for a particular state
/////////////////////////
protoVisit *initVisits::CreateVisit(register ubrick state)
{
register long transit = Generator->GenReduceHash[state];
register long x = transit >> BRICKHEADREDUCESHIFT; // x reflects the type of state
if ( x == B_ERROR_ )
 return new simpleVisit(state);

if ( Generator->GenShiftHash[state] == BRICKFFFF )
 return new finalVisit(state);

if ( x == B_SINGLE0_ || x == B_SINGLE0_ACTION_ )
 return new fullVisitSingle0(state, Steps);

return new fullVisit(state);
}


//////////////////////
//ExpandFork does not fork for all the
//visits except the expandVisit
//////////////////////
protoVisit *protoVisit::ExpandFork(register initVisits *) { return &stop; }



//////////////////////
//Picks up the new edge
//to advance from the simpleVisit and calls Shift to create
//a new visit to advance via that edge.
//Called only from lr1Tables::GenerateFromTo()
//right after the simpleVisit is created.
//////////////////////
protoVisit *simpleVisit::Advance_(register initVisits *iv)
{
if ( iv->Remains <= 0 )				// check bounds
 return &stop;
register visit &v = iv->Visits[State];		// this visit
if ( v.Edges.Counter >= Counter )		// no more edges...
 v.Edges.Counter = 0;				// start from the beginning
Current = (ubrick)(v.Edges.Counter++);		// now create a new visit!!!
return iv->Shift(this, Current);
}



//////////////////////
//Advances from visit to visit during expansion phase.
//may create new expandVisit (see comments below).
//////////////////////
protoVisit *protoVisit::ExpandAdvance(register initVisits *iv)
{
register protoVisit *nxt = NextVisit;
if ( !nxt )						// no place to go?
 return &stop;                          		// it is over...
register ubrick nonTerminal = nxt->IsNonTerminal();
if ( nonTerminal == BRICKFFFF )		// if it is a terminal
 return nxt;                            // return next visit
else                                    // otherwise -
{					// it is a nonterminal
 if (					// if we may generate nonterminals
					// and we return to the previous
					// level of expansion, or
     (!(Generator->Flag&F_messages) && Level != nxt->Level) ||

					// we must generate only terminals
					// and the next visit is hidden
     (Generator->Flag&F_messages && nxt->Flag&F_hide)
    )
   return nxt;                          // then return next

 register ubrick dist = (nonTerminal - Generator->MaxTerminal)<<1;
 register ubrick *rules = Generator->Rules;

 if (				// if nonterminals are allowed to generate,
				// and there are no rules derived from it,

      (!(Generator->Flag&F_messages) && !rules[dist + 1])

       ||			// or
				// there is a single rule nonTerminal : ;
      (rules[dist + 1] == 1 && !Generator->Lengths[rules[dist] + 1])
    )
   return nxt;			// return the next node
 if (				// if only terminals are allowed and
     Generator->Flag&F_messages &&

				// no rules expand this nonterminal, or
		 ( !rules[dist + 1] ||

				// or no terminals could be derived
		 Lr1Tables->Find(nonTerminal)->DerivedLength == BRICKEFFF )
    )
   return &stop;                // then stop!
}
					// otherwise, create the new
					// expandVisit
register expandVisit *expnd = new expandVisit(nxt, nonTerminal, iv->Remains,
					      iv->NonTerminals, iv->Delta);
expnd->Forks++;
if ( iv->Expand_(this, 0, expnd) == &stop )	// try to expand
{
 delete expnd;					// cannot...
 return &stop;
}
return expnd;					// expanded...
}


/////////////////////////////
//This function tries to expand the rule
//The only reason not to expand may be that the minimum
//length of the derived string will overlap the remaining
//length limit of the generated string.
/////////////////////////////
protoVisit *initVisits::Expand_(register protoVisit *it, register ubrick c,
			       register expandVisit *expnd)
{
				// minimal length of the string derived
				// from this rule
register ubrick minDerived = expnd->Deltas[c].DerivedLength;

				// minimal length of the string derived
				// from the nonterminal expnd->Token
				// (if only terminals are allowed);
				// 0 if there is a single rule 'Token ; ;';
				// 1 - otherwise
register ubrick takeIntoAccount = expnd->Delta();

if ( Remains + takeIntoAccount < minDerived )	// exit if we do not fit
 return &stop;

Remains += takeIntoAccount - minDerived;	// otherwise update limits
NonTerminals -= 1 - expnd->Deltas[c].NonTerminals;
c <<= 1;					// get members of the rule
register ubrick *members = Generator->Members + expnd->Rules[c];
register ubrick *end = members + expnd->Rules[c + 1];
register protoVisit *prev = expnd;
register genVisit *gen;
::Level++;					// new expansion level

#if defined(DEBUGEXPAND)
register ostream &f = Io;
f << "\n// " << expnd->GetToken() << " :";
#endif

while ( members < end )				// for each member of the rule
{
 gen = new genVisit(*members++, prev);

				// in the case were there is a single
				// rule 'gen->Token : ;', the next code
				// hides the generated node so that
				// it will not be printed out

 register ubrick delta = gen->Delta();		// less nodes to scan
 register int isItNonTerminal = gen->IsItNonTerminal();
 if ( !delta && isItNonTerminal )     		// single rule 'gen->Token:;'
 {
   register ubrick dist = (gen->IsNonTerminal() - Generator->MaxTerminal)<<1;
   register ubrick *rules = Generator->Rules;
   if ( rules[dist + 1] == 1 && !Generator->Lengths[rules[dist] + 1] )
      gen->Flag |= (F_hide|F_single0);
 }

#if defined(DEBUGEXPAND)
f << " " << gen->GetToken();
#endif

 prev = gen;                    		// get to the next meber...
}

#if defined(DEBUGEXPAND)
f << ';';
#endif

prev->NextVisit = expnd->Expand;        	// connect last visit
expnd->Expand->PrevVisit = prev;
expnd->Expand->Flag |= F_hide;                  // hide the expandVisit
expnd->Expand->Flag &= ~(F_reached|F_printed);
expnd->Level = ::Level;                         // record it's level
it->NextVisit = expnd;                          // connect expandVisit
expnd->PrevVisit = it;                          // with the previous one
Flush();                                        // try to print the sentence
return expnd;					// now return...
}


/////////////////////////
//This function chooses the next rule to expand
//after there has been some advancement from the
//current expandVisit. Works only at the axpansion stage.
/////////////////////////
protoVisit *expandVisit::ExpandFork(register initVisits *iv)
{
iv->Remains = Remains;   			// restore limits
iv->NonTerminals = NonTerminals;

register protoVisit *end = Expand;		// delete the expanded nodes
register protoVisit *current = NextVisit;
register protoVisit *prev = current;
while ( current != end )
	prev = current, current = current->NextVisit;
if (prev != end) {
	while ( prev != NextVisit ) {
		delete prev;
		prev = prev->PrevVisit;
	}
	delete prev;
}

if ( Forks++ >= Counter )                      // no more rules
 return &stop;
Current++;                                     // next rule
return iv->Expand_(PrevVisit, Current, this);  // try to expand...
}


///////////////////////////
//This function tries to advance through
//some new edge after some advancement has been done.
//Called only from lr1Tables::GenerateFromTo()
///////////////////////////
protoVisit *simpleVisit::Fork_(register initVisits *iv)
{
if ( iv->Remains <= 0 )				// check bounds
 return &stop;

register protoVisit *n;
do
{
 if ( Forks >= Counter )			// all edges has been forked
   return &stop;                                // failure to fork...
 Current++;                                     // next edge to fork
 if ( Current == Counter )                      // wrap around
   Current = 0;
 n = iv->Shift(this, Current);                  // now shift
} while ( n == &stop );                         // failure - try next edge
return n;                                       // o'k - fork through n'th edg
}


///////////////////////////
//Checks if there is advancement possible from
//the current visit towards the Target.
//Uses the 'distance' array which x[m][n] contains
//a number which is less than min{ dist(m,n) }.
///////////////////////////
int	initVisits::CheckDistance(register simpleVisit *pv,
				  register ubrick current)
{
register ubrick s = pv->Edges[current];
register brick *d = Distance[s];
if ( !d )				// no distance array has been created
{
 register ubrick n = Number;
 d = Distance[s] = new brick [n];	// make one
 while ( n-- )
   d[n] = -1;
 return 1;
}
return d[Target] < Remains - 1;		// has this state been pruned out?
}


////////////////////////
//This function actually creates a new visits
//and advances to it.  It is called from
//protoVisit::Advance() and protoVisit::Fork().
////////////////////////
protoVisit *initVisits::Shift(register simpleVisit *pv,
			      register ubrick current)
{
pv->Forks++;					// one more fork
register ubrick to = pv->Edges[current];        // shift state
if ( to == Target )                             // reached the target?
 return TargetState;

if ( !CheckDistance(pv, current) )		// has been pruned out?
 return &stop;

register protoVisit *n = GetVisit(to);		// now create the shift state
if ( !n )					// failure - final state
 return &stop;

register ubrick delta = n->Delta();		// less nodes to scan
Remains -= delta;
if ( (SoFarPassed(n) == Remains) && Remains )	// is it an empty loop?
{
 Delete(n);					// yes, backtrack...
 return &stop;
}
n->Passed = Remains;                            // remember current length

pv->NextVisit = n;				// link it to the current
n->PrevVisit = pv;

register int isItNonTerminal = n->IsItNonTerminal();

				// in the case were there is a single
				// rule 'n->IsNonTerminal : ;', the next code
				// hides the generated node so that
				// it will not be printed out

if ( !delta && isItNonTerminal ) 		// a single rule alpha : ;
{
 register ubrick dist = (n->IsNonTerminal() - Generator->MaxTerminal) << 1;
 register ubrick *rules = Generator->Rules;
 if ( rules[dist + 1] == 1 && !Generator->Lengths[rules[dist] + 1] )
 {
   n->Flag |= (F_hide|F_single0);
   return n;
 }
}
NonTerminals += isItNonTerminal;
return n;					// return the new visit
}


//////////////////////////
//Thisfunction prints out the generated sentence
//////////////////////////
void initVisits::Flush()
{
if ( Generator->Flag&F_messages && NonTerminals )	// there still are
 return;						// nonterminals...
register ostream &f = Io;
register protoVisit *from = Start;
f << endl;
do
{
 if ( !(from->Flag & F_hide) )
 {
   from->Flag |= F_printed;
   f << ' ' << from->GetToken();			// print it out
 }
 from->Flag |= F_reached;
} while ( (from = from->NextVisit) != NULL );
PathCounter--;						// one more sentence
}


////////////////////////
//This is the expansion function.
//It is called from lr1Tables::GenerateFromTo().
//Repeatedly expands nonterminals from the path
//and those which arrived during such expansion.
////////////////////////
int initVisits::Expand(register ubrick to)
{
register protoVisit *current = Start;

Flush();					// printout the path

register protoVisit *next = current->ExpandAdvance(this);// first advancement

while ( PathCounter )                           // up to the limit
{
 if ( !next )					// some error...
   return 0;
 if ( next == &stop || next->State == to )	// can not advance...
   for ( ;; )					// go back and fork...
   {
      if ( (next = current->ExpandFork(this)) != &stop )// found alternative
	  break;
      current->Flag &= ~(F_reached|F_printed);  // clear for further visits
      next = current->PrevVisit;
      if ( !next )
	  return 0;				// end of job
      if ( current->Type() == EXPANDVISIT_ )	// delete the expandVisit
      {						// to advance to next visit
	  next->Restore((expandVisit *)current, this);
	  if ( !(Generator->Flag&F_messages) )
	  {
	       current = next;
	       next = current->NextVisit;
	       break;
	  }
      }
      current = next;				// go back one state
   }
 else						// if can advance
 {
   current = next;				// then do it...
   if ( Generator->Flag&F_messages && !NonTerminals )	// do not advance
      next = &stop;				// after printout has happen
   else
      next = current->ExpandAdvance(this);
 }
}
return 1;					// found all needed sentences
}


/////////////////////////
//Delete the current expandVisit
/////////////////////////
void protoVisit::Restore(register expandVisit *expand,
			 register initVisits *iv)
{
iv->Remains = expand->Remains;			// restore limits
iv->NonTerminals = expand->NonTerminals;
register protoVisit *nextVisit = expand->Expand;// next visit
nextVisit->PrevVisit = this;			// connect it with the current
if ( !(nextVisit->Flag&F_single0) )		// was it single 'alpha : ;'?
 nextVisit->Flag &= ~F_hide;			// no - do not hide anymore
delete expand;					// gone...
NextVisit = nextVisit;				// connect current with next
}



//////////////////////////
//Memory management for protoVisit
//////////////////////////
void *protoVisit::operator new(size_t size)
{
if ((char*) currLoc + size > (char*) atEnd + CHUNK)
{
 currLoc = (protoVisit*) new char [CHUNK];
 currLoc->next = NULL;
 atEnd->next = currLoc;
 atEnd = currLoc;
}
protoVisit *newFree = currLoc;
currLoc = (protoVisit*) ((char*)currLoc + size);
return (newFree);
}
 
void protoVisit::operator delete(void* p)
{
currLoc = (protoVisit*) p;
if ((currLoc != freeStore) && (currLoc == atEnd))
{
 protoVisit *curr, *prev;
 curr = prev = freeStore;
 while (curr != atEnd)
 {
   prev = curr;
   curr = curr->next;
 }
 prev->next = NULL;
 atEnd = prev;
 delete [] (char*)currLoc;
}
}

void freeAll()
{
while (freeStore) 
{
 register protoVisit *next = freeStore->next;
 delete [] (char*)freeStore;
 freeStore = next;
}
}
