#
# MASTER INFORMATION SYSTEMS CORPORATION
# Copyright (c) 1996
#
# make and run all MUSKOX examples
#
# Do not forget to set CPP=C on Pyramid, CPP=cpp on SPARC
#

#CPP=C
#CPP=cpp

#
# run all examples
#
all:	examples_CC examples_GNU
	rm -f all.results test.out

#
#
#
examples_CC:	
		csh -c "setenv CCPLUS CC; setenv CCFLAGS -O2; make examples run -f examples.mk"

examples_GNU:	
		csh -c "setenv CCPLUS g++; setenv CCFLAGS -O2; make examples run -f examples.mk"

#
#
#
examples_CC_all:	
		csh -c "setenv CCPLUS CC; setenv CCFLAGS ${CCFLAGS}; setenv CPP ${CPP}; make examples run -f examples.mk"

examples_GNU_all:	
		csh -c "setenv CCPLUS g++; setenv CCFLAGS ${CCFLAGS}; setenv CPP ${CPP}; make examples run -f examples.mk"

#
#
#
examples:
		make clobber -f examples.mk
		make exp   -f exp.mk	
		make famby -f famby.mk	
		make sym   -f sym.mk	
		make t510  -f t510.mk	
		make t512  -f t512.mk	
		make t5122 -f t5122.mk	
		make t5123 -f t5123.mk	
		make t513  -f t513.mk	
		make t514  -f t514.mk	
		make t516  -f t516.mk	
		make t517  -f t517.mk	
		make t5151 -f t5151.mk	
		make t5152 -f t5152.mk	
		make t55   -f t55.mk	
		make t56   -f t56.mk	
		make t57   -f t57.mk	
		make t59   -f t59.mk	
		make t611  -f t611.mk	
		make t614  -f t614.mk	
		make t62   -f t62.mk	

run:
		all.run >> all.results
		cat all.results
		cat lg/all.out >> all.out.${CCPLUS}

clobber:
	rm -f *.d *.o *.v *.m *.?0\
	      t5*.h t6*.h \
	      t5*.$(CPP) t6*.$(CPP) \
	      famby.h famby.$(CPP) \
	      sym.h sym.$(CPP) \
	      exp.h exp.$(CPP) \
	      *.exr \
	      *.log \
	      lg/*.* \
	      exp \
	      famby \
	      sym   \
	      t510  \
	      t512  \
	      t5122 \
	      t5123 \
	      t513  \
	      t514  \
	      t516  \
	      t517  \
	      t5151 \
	      t5152 \
	      t55   \
	      t56   \
	      t57   \
	      t59   \
	      t611  \
	      t614  \
	      t62   
	touch *.ms


#
# move everything out from examples to ${MUSKOX_ROOT}/${GOAL}
# ${MUSKOX_ROOT} should be the parent directory of examples
#
TARGET = ${MUSKOX_ROOT}/${GOAL}

${GOAL}:	clobber
	rm -rf ${TARGET}
	mkdir ${TARGET}
	mkdir ${TARGET}/examples
	cp test.run all.run *.ms *.mk *.inp          ${TARGET}/examples
	cp expmain.cpp symmain.cpp explex.h symlex.h ${TARGET}/examples
	cp README.1ST license.${GOAL} install.sh ${TARGET}
	cp ${MUSKOX_ROOT}/mskx.${GOAL} ${TARGET}/mskx
	chmod a-w ${TARGET}/README.1ST ${TARGET}/mskx ${TARGET}/license.${GOAL}
	chmod a+x ${TARGET}/mskx
	mkdir ${TARGET}/examples/lg.ok
	cp lg.ok/* ${TARGET}/examples/lg.ok
	chmod a-w ${TARGET}/examples/lg.ok/*
	mkdir ${TARGET}/framework
	mkdir ${TARGET}/engine
	mkdir ${TARGET}/headers
	cp nodus.cpp pc.cpp                                ${TARGET}/framework
	cp inpus.cpp skeletus.cpp skelbmon.cpp generus.cpp ${TARGET}/engine
	cp nodus.h pc.h bml.h atribus.h skeletus.h         ${TARGET}/headers
	cp inpus.h skelbmon.h generus.h                    ${TARGET}/headers
	rm -rf ${MUSKOX_ROOT}/muskox
	mv ${TARGET} ${MUSKOX_ROOT}/muskox
	cd ${MUSKOX_ROOT}/; tar -cf MUSKOX.TAR muskox; compress -f MUSKOX.TAR
	chmod a-w ${MUSKOX_ROOT}/MUSKOX.TAR.Z
	mv ${MUSKOX_ROOT}/MUSKOX.TAR.Z ${MUSKOX_ROOT}/muskox
	mv ${MUSKOX_ROOT}/muskox ${TARGET}
	ln -s ${TARGET}/mskx  ${TARGET}/examples/mskx
