/////////////////////////////////////////////////////////////
//                                                         //
// Copyright 1994, 1995, 1996                              //
// MASTER INFORMATION SYSTEMS CORPORATION                  //
// MUSKOX Version 1.2					   //
// All Rights Reserved                                     //
//                                                         //
/////////////////////////////////////////////////////////////

#include <stdlib.h>
#include <iostream.h>
#include <ctype.h>
#include <string.h>

#include "atribus.h"
#include "inpus.h"
#include "skeletus.h"

#include "exp.h"
#include "explex.h"
#include "exp.m"				// grammar symbols

#ifdef __MWERKS__
#include <console.h>
#endif


//
// redefine error reporting
//

extern expLex eLex;

int	myError::UserRecover(lr1Tables *, stack *, lex *, // no user recovery
			ubrick (lex::*)(void *), ubrick *)
{
return 0;
}

						// report error and print stack
void	myError::ReportError(lr1Tables *tab, stack *stck, lex *l, ubrick *token)
{
cerr << "\nexp: Syntax error at <" << l->GetToken(*token)
     << ">, ParseStack:";

register stackElement *sp = stck->StackLimit;

while ( sp <= stck->Stack )
{
 cerr << "\n\t" << sp->State << " - " << tab->DebugHash[sp->State]->Word;
 sp++;
}
}


//
// redefine error limit
//
						// up to 10 errors
int myError::ErrorLimit()
{
return 10;
}


//
// redefine lexical analyzer
//

ubrick myLex::PureUserLex(void *) {return 0;}

ubrick expLex::PureUserLex(register void *a)
{
for ( ;; )
{
 register char *s = Pointer;
 switch (*Pointer++ )
 {
   case '+': return __l_43__exp;
   case '-': return __l_45__exp;
   case '(': return __l_40__exp;
   case ')': return __l_41__exp;
   case '*': return __l_42__exp;
   case '/': return __l_47__exp;
   case ' ':
   case '\t':
   case '\n': continue;
   case 0:    return _ENDoFsTREAM_exp;
   default:   if ( !isdigit(*s) )
		return _OTHER_exp;		// lexical error
	      while ( isdigit(*Pointer) )
		Pointer++;
	      *((long *)a) = atol(s);
	      return _NUMBER_exp;
 }
}
}


//
// declare generated objects
//

extern  mskx  mskx_exp;			// generated parser,lexer,error
extern  lex   lexer_exp;
extern  error error_exp;

extern  exp  this_exp;			// generated type object

//
// redefine lexer and error objects
//

expLex eLex(&lexer_exp);			// redefine lexer and error
myError myError_exp(&error_exp);

//
// initialize static members
//

int lr1Tables::Flag = 0;
ostream *lr1Tables::Cerr = &cerr;

//
// exp parser
//
// calculates the result of an arithmetic expression that
// involves addition, subtraction, unary plus and minus, and
// grouping in parenthesis.
//
// place expression in qoutes as a single command line argument,
// for example:
//		exp "2+3-5"
//

main(register int argc, register char *argv[])	// parser
{

#ifdef __MWERKS__
argc = ccommand(&argv);
#endif

int ret = 0;					// exit status

if ( argc < 2 )
{
 cerr << "expression is missing\n";
 exit(1);
}

char e[1024];					// prepare the expression

e[0] = 0;
register int i = 0;
while ( ++i < argc )
 strcat(e, argv[i]);

eLex.Pointer = e;				// input buffer

//
// prepare for parsing
//

mskx_exp.Lex = &eLex;				// reset lexer
mskx_exp.Error = &myError_exp;			// reset error
myError_exp.Flag &= ~(F_NOPOP|F_NOSKIP);	// continue parsing on errors

mskx_exp.Lr1Tables->DebugReset();		// no debugging printouts
mskx_exp.Lr1Tables->ErrorProc = &myError_exp;   // for error reporting

//
// parse the expression
//

cerr << endl << "EXP: ";

if ( !mskx_exp.Success() )			// parse!!!
{
 cerr << endl << mskx_exp.Error->Number << " syntax error(s)";
 ret = 1;
}
else
{
 cerr << "Result = " << this_exp.Result;
 ret = 0;
}
cerr << endl;

return ret;
}
