/////////////////////////////////////////////////////////////
//                                                         //
// Copyright 1994, 1995, 1996                              //
// MASTER INFORMATION SYSTEMS CORPORATION                  //
// MUSKOX Version 1.2					   //
// All Rights Reserved                                     //
//                                                         //
/////////////////////////////////////////////////////////////


{ // extracode

#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <stdio.h>

	struct product
	{
		char *Name;
		char *Price;
		void MakeOrderName(char *buf, long number)
		{
			sprintf(buf, "order_%ld_", number);
			strcat(buf, Price);
			strcat(buf, "_");
			strcat(buf, Name);
		}
		product(register char *c);
	};
	product::product(register char *c)
	{
		Price = c;
		while ( isdigit(*c) )
			c++;
		*c++ = 0;
		while ( isspace(*c) )
			c++;
		Name = c;
	}
}

abstract type interface
{
public:
static	FILE *LogFile;
	long Session;
	long PreviousState;
	long PreviousSymbol;
	interface() {
		      Session = 0;
		      if ( !LogFile )
		      {
			 (void)remove("family.log");
			 LogFile = fopen("family.log", "w");
		      }
		      PreviousState = PreviousSymbol = -1;
		    }
	~interface(){
		      if ( LogFile )
		      {
		         fclose(LogFile);
			 LogFile = 0;
		      }
		    }
	void Log()
	{
	  if ( CurrentState != PreviousState || LastSymbol != PreviousSymbol )
	  {
	     fprintf(LogFile,
		     "\nObject <%s>, state <%s> %ld, symbol <%s> %ld, #%ld",
			ObjectName,
			GetSymbol(CurrentState), CurrentState,
			GetSymbol(LastSymbol), LastSymbol,
			++Session);
	     PreviousState = CurrentState;
	     PreviousSymbol = LastSymbol;
	  }
	}
}
[
message public CancelOrder       {char *}
	       IncreaseBudget    {char *}
	       DecreaseBudget    {char *}
	       VerifyBudget      {char *}
	       VerifyAndDecrease {char *}
	       Found             {char *}
	       ManualOrder       {char *}
	       OrderPurchase     {char *}
	       LaunchAgent       {order *}
	       MakePurchase      {order *}
	       Ok;

state public   wait
	       cancelled
	       linking
	       linked
	       ;

state public left   bought 
		    noMoney 
		    notFound;

state public right  cancel 
		    shopping;

trigger {Log();};
];

{				// extracode
FILE *interface::LogFile = 0;
}

type control;			// type declarations
type budget;
type order;
type agent;
type launchPad;

type familyMember(control c, budget b) : public interface
{
public:
	char    *Name;
	familyMember(char *c = "Patches") { Name = c; }
}
[
	LIFE : <
		  OrderPurchase   ( {$1} - c )
		|
		  ManualOrder     ( {$1} - c )
		|
		  CancelOrder     ( {$1} - c )          
		|
		  IncreaseBudget  ( {$1} - b )          
		|
		  DecreaseBudget  ( {$1} - b )
	       >*;
];

type order (agent a) : public interface
{
public:
	product *Product;
}
[
	state private cancelling;
	begin wait;

	LIFE : bought | cancelled | noMoney | notFound;

	linking : wait linking@a;
	shopping : linking shopping@a;

	select <bought noMoney notFound> : shopping;

	cancelling : shopping cancel (- a);

	cancelled : <linking | wait | cancelling> cancel
		  | cancelled <linking@a | shopping@a> (cancel - a);

	select <bought noMoney notFound> : cancelling;

	repeat <bought cancelled noMoney notFound> : cancel;
];

type manualOrder(budget b) : public interface
{
public:
	product *Product;
}
[
	begin shopping;

	LIFE : bought | noMoney | notFound | cancelled;

	select <noMoney notFound> : shopping;
	bought : shopping bought {Send(b(), DecreaseBudget, &$2);};

	cancelled : shopping cancel;
];


type agent(order o, budget b) : public interface
{
public:
	void GoShopping(order *){};
	void Buy(){};
	void KillProcess(){};
	void LaunchProcess(){};
	void DestroyLink() {o()->UnLink(this, "a"); UnLink(o(), "o");}
	void LinkOrder(order *o) {Link(o, "o"); o->Link(this, "a");}

}
[
	state public init free kill;
	begin init;

	LIFE : init (free - .) free+;

	free : shopping
	       <
		  cancel kill (- o)
		|
		  notFound (- o) kill
		|
		  Found (VerifyAndDecrease - b)
		  <
		     Ok {Buy();} (bought - o)
		   |
		     noMoney (- o) kill
		  >
	       > {DestroyLink();}

	     | linking cancel {DestroyLink();} (- o)

	     | free cancel;
	     ;

	shopping : linking linking@o {LaunchProcess();};

	linking : free MakePurchase {LinkOrder($2);};

	kill : {KillProcess();};
];


type control(budget b, launchPad l,
	     manualOrder m ..., order o ...) : public interface
{
public:
	long	     NumberOfOrders;	// total number of orders
	product     *OrderedProduct;    // the ordered product
	order       *NewOrder;          // newly created order object

	void       CreateOrder()        // create new order
		   {
		    ////// make name for new order object
		    char *orderName = new char [256];
		    OrderedProduct->MakeOrderName(orderName, ++NumberOfOrders);

		    ////// create a new order object
/********
This code works fine on g++, Microsoft (16 & 32 bits), 
Borland, MetroWerks, and SUN C++ compilers
********/
		    NewOrder = order::Create(orderName);

/********
This code causes famby to abort when compiled with g++

		    NewOrder = new order;
		    NewOrder->BringUp(orderName);
********/
		    NewOrder->Product = OrderedProduct;

		    ////// link it to the list of auto orders
		    Link(NewOrder, "o");
		   }
	void	   CreateManualOrder()	// create manual order
		   {
		    ////// make name for new order object
		    char *orderName = new char [256];
		    OrderedProduct->MakeOrderName(orderName, ++NumberOfOrders);

		    ////// create a new manualOrder object
		    manualOrder::Create(orderName);
		    manualOrder::Self->Product = OrderedProduct;

		    ////// link it to the list of manual orders
		    Link(manualOrder::Self, "m");

		    ////// link budget ot the new manual order
		    manualOrder::Self->Link(b(), "b");
		   }
	void 	   CreateAgent(char *name)
		   {
		    agent *a = agent::Create(name);
		    l()->Link(a), a->Link(b(), "b");
		   }

	control() { NumberOfOrders = 0; OrderedProduct = 0; NewOrder = 0; }
}
[
	state private createAgents;
	begin createAgents;

	trigger createAgents { CreateAgent("a1"), CreateAgent("a2"); };

	trigger noMoney
		{OrderedProduct = 0; NewOrder = 0;};

	trigger	<OrderPurchase ManualOrder>
		{OrderedProduct = new product($$);
		 Send(b(), VerifyBudget, &OrderedProduct->Price);}
	;

	LIFE : createAgents
	       <
		  OrderPurchase
			<
			   Ok {CreateOrder();}
			      (LaunchAgent {NewOrder} - l)
			 |
			   noMoney
			>
		|
		  CancelOrder {order *ord = order::Locate($1);
			       if ( ord )
					Send(ord, cancel);}
		|
		  ManualOrder
			<
			   Ok {CreateManualOrder();}
			 |
			   noMoney
			>
	       >+;
];

type budget : public interface
{
public:
	long     Budget;
	long     Value;
	budget(long b = 0) { Budget = b; Value = 0; }
}
[
	trigger <
		  IncreaseBudget
		  DecreaseBudget
		  VerifyBudget
		  VerifyAndDecrease
		>
		  { Value = atol($$); };

	LIFE : <
		  IncreaseBudget    { Budget += Value; }
		|
		  DecreaseBudget    { Budget -= Value; }
		|
		  VerifyBudget      {
				      if (Budget - Value >= 0)
					SendBack(Ok);
				      else
					SendBack(noMoney);
				    }
		|
		  VerifyAndDecrease {
				      if (Budget - Value >= 0)
				      {
					Budget -= Value;
					SendBack(Ok);
				      }
				      else
					SendBack(noMoney);
				    }

	       >*;

];

type launchPad(agent ...) : public interface
[
	message public delay  LaunchAgent {order *};
	state   public delay  free@?;

	LIFE : <
		  LaunchAgent { RePost(); }
			free@? ( MakePurchase {$1} - ^ ) { RePost(); }
	       >*;
];

//
// part 2 -- static famby objects
//

budget 	{Budget = 3000;} 	money;

launchPad			launch;

control(b money, l launch)	famby;

familyMember(famby, money) 	{ Name = "Sam"; } 	son,
				{ Name = "John"; }   	dad,
				{ Name = "Mary"; }  	mom,
				{ Name = "Patches"; } 	cat;

