/////////////////////////////////////////////////////////////
//                                                         //
// Copyright 1994, 1995, 1996                              //
// MASTER INFORMATION SYSTEMS CORPORATION                  //
// MUSKOX Version 1.2					   //
// All Rights Reserved                                     //
//                                                         //
/////////////////////////////////////////////////////////////

{
#include <fstream.h>
#include <string.h>
#include <stdlib.h>
#include <stddef.h>
#include <ctype.h>
#include "symlex.h"


extern stack stack_sym;
extern mskx mskx_sym;
extern symLex sLex;

struct name 
       {
         char *FormulaName;
         char *Formula;
         name *Next;
         name(register char *fn, register char *n, register name *nx)
         {
           FormulaName = fn;
           Formula = n;
           Next = nx;
         }
       };
}

type sym
{
public:
	long Result;
	long Calc;
        name *Formulae;
	sym() { Result = 0; Calc = 1; Formulae = 0;}
	void RecursiveParse(register name *n)
	{
         stack r(stack_sym);       // declare recursive stack
         stack *s = mskx_sym.Stack;// save current stack

         mskx_sym.Stack = &r;      // reset current stack
	 mskx_sym.Lr1Tables->Stack = &r;

	 char *p = sLex.Pointer;   // reset input pointer
	 sLex.Pointer = n->Formula;

	 (void)mskx_sym.Success(); // parse

	 sLex.Pointer = p;         // restore input pointer
                        
         mskx_sym.Stack = s;       // restore current stack
         mskx_sym.Lr1Tables->Stack = s;
	}
}
[
attribute long;

state expression calculation formula;
message NUMBER;
message NAME {char *};

message left '+' '-';
message left '*' '/';

LIFE : formula+ calculation
     | calculation
     | expression { Result = $1; }	// for recursive calculations
     ;

formula    : NAME       { Calc = 0; } 
	     ':'
	     expression {
			 sLex.Pointer[-1] = 0; // report ENDoFsTREAM recursively
                         Formulae = new name($1, sLex.Expression, Formulae);
                         Calc = 1; 
                        }
	     ';'
           ;

calculation: expression '=' { Result = $1; }
           ;

expression : expression '+' expression { if ( Calc ) $$ = $1 + $3; }
	   | expression '-' expression { if ( Calc ) $$ = $1 - $3; }
	   | expression '*' expression { if ( Calc ) $$ = $1 * $3; }
	   | expression '/' expression { if ( Calc ) $$ = $1 / $3; }
           | '(' '-' expression ')' { if ( Calc ) $$ = -$3; }
	   | '(' '+' expression ')' { if ( Calc ) $$ = $3; }
           | '(' expression ')' { if ( Calc ) $$ = $2; }
           | NUMBER { if ( Calc ) $$ = $1; }
           | NAME { 
                   if ( Calc ) 
                   {
		     name *n = Formulae;
                     while ( n )
                     {
                        if ( !strcmp(n->FormulaName, $1) )
                        {
			    RecursiveParse(n);
                            $$ = Result;
                            return;
                        }
                        n = n->Next;
                     }
                     cerr << endl << "Undefined formula <" << $1 << '>'
                          << endl;
                     exit(1);
                   }
                   
                  }
           ;
];
