/////////////////////////////////////////////////////////////
//                                                         //
// Copyright 1994, 1995, 1996                              //
// MASTER INFORMATION SYSTEMS CORPORATION                  //
// MUSKOX Version 1.2					   //
// All Rights Reserved                                     //
//                                                         //
/////////////////////////////////////////////////////////////

// 5.11

//
// type definitions
// describe a database server that may consist of OS processes, data
// files for application data and for logging of its operations, and that
// may have connections to similar remote servers
//

type file[];			// no children

type process[];			// no children

type data(file ...)[];		// any number of children type file,
				// the link has no name

type server(process proc ..., 	// any number of children type process,
				// 	the link is named 'proc'
            data log, 		// one child of type data,
				//	the link is named 'log'
            data appl, 		// one child of type data,
				//	the link is named 'appl'
            server remote ...)  // any number of children type server,
				//	the link is named 'remote'
            [];

//
// definition and declaration of objects
//

process tp_monitor, kernel, listener, writer;	// objects with no children

file l1, l2, l3, a1, a2, a3, a4;		// objects with no children

data(l1, l2, l3) log_data;	// log_data is a parent object
				//	for the children l1, l2, and l3

data(a1, a2, a3, a4) appl_data;	// appl_data is a parent object
				// to the children a1, a2, a3,  and a4

declare server New_York;	// this is just a declaration of an object
				// to allow use its name subsequently as
				// a name of a child

//
// definition of the object San_Francisco
//
server(proc tp_monitor, 	// children connected via the link 'proc'
       proc kernel, 
       proc listener, 
       proc writer,

       log log_data,		// a child connected via the link 'log'

       appl appl_data,		// a child connected via the link 'data'

       remote New_York)  	// a child connected via the link 'remote'

		San_Francisco;
