/////////////////////////////////////////////////////////////
//                                                         //
// Copyright 1994, 1995, 1996                              //
// MASTER INFORMATION SYSTEMS CORPORATION                  //
// MUSKOX Version 1.2					   //
// All Rights Reserved                                     //
//                                                         //
/////////////////////////////////////////////////////////////

// 5.13

{
#include <stdio.h>
#include <stdlib.h>
}

type file
{
public:
	char *FileName;
	FILE *Fd;
	long  WriteCount;
	file(char *f = "") { FileName = f; Fd = 0; WriteCount = 0; }
}
[
	message public left REPORT;
	state public left open_ closed ioDone jobDone failed;
	message public Open Close
		       Read Write {char *};

	LIFE : jobDone+;
	jobDone : open_ ioDone closed 
		| failed;

	select <open_ failed> : Open 
                      {Send(((Fd = fopen(FileName, "w+"))!=NULL)?open_:failed);};

	closed  : Close
			{(void)fclose(Fd); Fd = 0;};
	ioDone  : <
		   Read
		  |
		   Write {(void)fputs($1, Fd); ++WriteCount;}
		  >*;

	repeat <open_ closed> : REPORT { cerr << "\nCurrent state is "
                                             << GetSymbol(CurrentState)
                                             << endl; };
];

type data(file l1, file l2)
[
	state public on off;
	message public Open {char *} Close;

	LIFE : <on | off>+;

	on   : Open (->)
	       <
		open_@l1 open_@l2
		|
		open_@l2 open_@l1
	       >;

	off  : Close (->)
	       <
		closed@l1 closed@l2
		|
		closed@l2 closed@l1
	       >;
];


file { FileName = "t513_1.exr"; } t513_1,
     { FileName = "t513_2.exr"; } t513_2;

data(t513_1, t513_2) p513;
