/////////////////////////////////////////////////////////////
//                                                         //
// Copyright 1994, 1995, 1996                              //
// MASTER INFORMATION SYSTEMS CORPORATION                  //
// MUSKOX Version 1.2					   //
// All Rights Reserved                                     //
//                                                         //
/////////////////////////////////////////////////////////////

// 5.17

{
#include <stdio.h>
#include <stdlib.h>
}

type file
{
public:
	char *FileName;
	FILE *Fd;
	long  WriteCount;
	file(char *f = "") { FileName = f; Fd = 0; WriteCount = 0; }
}
[
	state public open_ closed ioDone jobDone;
	message public Open Close
		       Read Write {char *};

	LIFE : jobDone+;
	jobDone : open_ ioDone closed;
	open_   : Open
			{Fd = fopen(FileName, "w+");};
	closed  : Close
			{(void)fclose(Fd); Fd = 0;};
	ioDone  : <
		   Read
		  |
		   Write {(void)fputs($1, Fd); ++WriteCount;}
		  >*;
];

type data(file ...)
[
	attribute {char *};

	state public on off waitOn waitOff;
	state public open_ closed jobDone;
	state private any;

	message public Open {char *} Close;

	trigger <Open Close> (->); //propagate messages to children

	LIFE : <on | off>+;

	any : on | off | waitOn | waitOff;

	waitOn   : Open;	   //become on when all children are open
	select <waitOn on> : any open_@?
				{Send(AllChildrenState(open_)?on:waitOn);};

	waitOff  : Close;          //become off when all children are off
	select <waitOff off> : any closed@?
				{Send(AllChildrenState(jobDone)?off:waitOff);};
];

type sysadm(sysadm peer ..., data server ...)
{
public:
	typeProto *Sender;
	sysadm() {Sender = 0;}
}
[
	attribute {char *};

	state   public working vacation quit fired;

	message public Transmit;

	message VacationReturn VacationGone;

	trigger { 
                     if ( !Verify() )	// verify links constantly
                        cerr << "\n"
                             << GetSymbol(LastSymbol) << " - "
			     << " broken - " << ObjectName; 
                };

	trigger Transmit {Sender = LastSender->LastSender;};

	trigger VacationReturn {UnLink(Find($$), "peer");};

	trigger <on@server off@server> {Sender = LastSender;};


	begin working;


	LIFE : working working* <quit | fired>;

	vacation : VacationGone { Link(Find($1), "peer"); };

	working : vacation VacationReturn;

	repeat <working> :
			  <
			   on@server  Transmit-
				       {
					cerr << "\nsysadm " << ObjectName
					     << ": data server "
					     << Sender->ObjectName
					     << " just went on";
				       }
			   |
			   off@server Transmit-
				       {
					cerr << "\nsysadm " << ObjectName
					     << ": data server "
					     << Sender->ObjectName
					     << " just went off";
				       }
			  >;
	repeat <vacation quit fired> : <on@server | off@server> 
					                     (, Transmit - peer)
			   {
			    cerr << "\n\n\tsysadm " << ObjectName
				 << " is not working,"
				 << "\n\ttransmitted received symbol "
				 << GetSymbol(LastSymbol) << " from server "
				 << Sender->ObjectName << " to peers\n";
			   };

];
