/////////////////////////////////////////////////////////////
//                                                         //
// Copyright 1994, 1995, 1996                              //
// MASTER INFORMATION SYSTEMS CORPORATION                  //
// MUSKOX Version 1.2					   //
// All Rights Reserved                                     //
//                                                         //
/////////////////////////////////////////////////////////////

#ifndef BMON
# define BMON
#endif

#include <string.h>
#include <iostream.h>
#include <ctype.h>
#include <stddef.h>
#include <fstream.h>
#include <stdlib.h>
#include <stdio.h>

#include "nodus.h"

#ifndef __V10_COMPATIBILITY__
# include "pc.h"
#else
# include "bm.h"
#endif


/******************************************************************_COMMENT

The file contains definitions of member-functions for the typeProto
class defined in nodus.h, and DerivedFrom() methods from nodePointer
and mskxBMon classes.

COMMENT_******************************************************************/


#ifdef __V10_COMPATIBILITY__
extern bmNodes       *currentNodeLib; // defined in the base framework
extern bmNodes       *allNodeLib;     // ...
#endif

mskxBMon *lookUpTypes(char *);
typeProto *lookUpObjects(char *);

////////////////////////////////////////////////////////////////////////////
mskxBMon    *nodePointer::DerivedFrom(mskxBMon *u) // check the type
{
register mskxBMon *un = ParentChild->Tables_us;    // get the type
if ( un == u )					   // exact match?
 return u;					   // yes...
return un->DerivedFrom(u);			   // no - check if derived
}

////////////////////////////////////////////////////////////////////////////
mskxBMon *mskxBMon::DerivedFrom(register mskxBMon *u)	// check if derived
{
if ( !strcmp(Name, u->Name) )				// exact type?
 return u;						// got it...
register baseTypes *b = BaseTypes;			// get the base types
if ( !b )						// no base types
 return 0;						// failure...
register int c = b->Counter;				// number of base types
if ( !c )						// no base types
 return 0;						// failure...
register mskxBMon **bs = b->Bases;			// first base type
register mskxBMon **bse = bs + c;			// last base type
do							// for all base types
{
 register mskxBMon *ud = (*bs)->DerivedFrom(u);		// derived?
 if ( ud )						// yes
   return ud;						// return o'k
} while (++bs < bse );					// keep rolling
return 0;						// failed...
}
////////////////////////////////////////////////////////////////////////////

//
// typeProto members
//
////////////////////////////////////////////////////////////////////////////

extern localQue local;				// local message que
localQue *typeProto::Local = &local;		// pointer within the node

////////////////////////////////////////////////////////////////////////////

void typeProto::RePost() 		 // repost delay que to the local que
{ Local->MergeQue(Delay); }

////////////////////////////////////////////////////////////////////////////

typeProto::typeProto() : childsAndParents(), actions(), os() // constructor
#ifdef __V10_COMPATIBILITY__
{ NodeFlags = 0; AutoSignalBits = 0; Delay = new localQue; }
#else
{ Flags = 0; AutoSignalBits = 0; Delay = new localQue; }
#endif

////////////////////////////////////////////////////////////////////////////

long typeProto::HasException(register mskxBMon **el, register mskxBMon *t)
{
if ( el )
{
 register mskxBMon *e;
 while ( (e = *el++) != NULL )
   if ( t == e || t->DerivedFrom(e) )
      return 1;
}
return 0;
}

////////////////////////////////////////////////////////////////////////////

void typeProto::InitStackAndError()	// init stack and error objects
{
Stack = new stack(STACK, Tables_us->Lr1Tables->Tokens,
		  Tables_us->MaxTokens, Tables_us->Lr1Tables->StartState);

Error = new errorBMon;

Lex = Tables_us->Lr1Tables->Lex;

if ( Tables_us->Lr1Tables->Init >= 0 )	// send initial state
 Send(Tables_us->Lr1Tables->Init);
}

////////////////////////////////////////////////////////////////////////////

void typeProto::Address()		// get address of parsing tables
{
This = this;
//Children = 0;
//Parents = 0;
Trans = 0;
LastSender = 0;
Tables_us = lookUpTypes(TablesName_us);
CurrentState = Tables_us->Lr1Tables->Init;
LastSymbol = Tables_us->Lex->Other;
LastAttribute = "";
//Tables_us->Lr1Tables->DebugSet(&cout);
InitStackAndError();
AllFixedLinks();
}


////////////////////////////////////////////////////////////////////////////

void typeProto::Address(typeProto *&cp, char *nn, // get address of the named
			char *an, int l, int v)   // node, link parents&children
{
register typeProto *tpn = lookUpObjects(nn);	  // find the child node
if ( tpn )
{
 if ( v && Children )                             //many children for named link
 {
   register nodePointer *np = Children;
   register int i = 0;
   do
   {
      register char *cn = np->ChildName();
      if ( cn && !strcmp(an, cn) )			  // already there
      {                                                   // add to the list
	  np->Down = new nodePointerFixed(tpn, np->Down, cp, an, 0);
	  l = Tables_us->Links->Counter - i - 1;
	  goto cont;
      }
      i++;
   } while ( (np = np->Link) != NULL );
   Children = new nodePointerFixed(tpn, Children, cp, an, v);//create child and
						       //parent the first time
 }
 if ( !v && Children )	// single child for named link
 {
   register nodePointer *np = Children;
   do
   {
      register char *cn = np->ChildName();
      if ( cn && !strcmp(an, cn) )			  // found single child
	  break;
   } while ( (np = np->Link) != NULL );
   np->ParentChild = tpn;
   ((nodePointerFixed *)np)->ChildFixed = &cp;
   cp = tpn;
 }

cont:

 Address0(tpn);
 MakeAutoReports(tpn, tpn->Parents, l);		  // autoReport for this child
}
}


////////////////////////////////////////////////////////////////////////////

void typeProto::Address(typeProto *&cp, char *an, int v)// make dummy fixed link
{
Children = new nodePointerFixed(0, Children, cp, an, v);
}

////////////////////////////////////////////////////////////////////////////

void typeProto::Address(register typeProto *tn)// put node on the list of
{					       // fixed nodes
Children = new nodePointer(tn, Children);      // create a child and a parent
Address0(tn);
}

////////////////////////////////////////////////////////////////////////////


void typeProto::Address0(register typeProto *tn)// link parent, make transtables
{
tn->Parents = new nodePointer(this, tn->Parents);
InitTransTable(tn, this, Children);
tn->InitTransTable(this, tn, tn->Parents);
}

////////////////////////////////////////////////////////////////////////////


void typeProto::Address(char *n)	   // put node on the list of variable
{					   // nodes
register typeProto *tpn = lookUpObjects(n);
if ( tpn )				   // node exists
{
 bml(MLEV) << "linking ObjectName =<" << ObjectName << ">, tpn = <"
	  << tpn->ObjectName << ">";
 Address(tpn);				   // link it
 MakeAutoReportsForAnyKid(tpn, tpn->Parents);// autoReport for this child
}
else
{
 bml(MLEV) << "No link for n =<" << n << ">";
}
}

////////////////////////////////////////////////////////////////////////////

void typeProto::MakeAutoReports0(register typeProto *child,
				 register nodePointer *link,
				 register autoReport *a)
{
register autoReport *a0 = a;
while ( a->Report )			// how many auto reports?
 a++;
if ( a == a0 )				// no auto reports (in case...)
 return;
register autoSignal *as = new autoSignal [(int)((a-a0)+1)];// space for auto signals
delete [] link->AutoSignal;
link->AutoSignal = as;
register lexBMon *l = child->Tables_us->Lex;
do					// fill in signals
{
 as->Signal = a0->Report;
 as->AtState = l->FindToken(a0->State);
 as++;
} while ( ++a0 < a );
as->Signal = 0;
as->AtState = -1;			// append by zeros
}

////////////////////////////////////////////////////////////////////////////

void typeProto::MakeAutoReports(register typeProto *child,
				register nodePointer *link, register int n)
{
register autoReport **ar = Tables_us->Links->AutoReportForKid;
if ( !ar )				// no any autoreports
 return;
register autoReport *a = ar[n];
if ( !a )				// no auto report for the link
 return;
MakeAutoReports0(child, link, a);
}

////////////////////////////////////////////////////////////////////////////


void typeProto::MakeAutoReportsForAnyKid(register typeProto *child,
				         register nodePointer *link)
{
register autoReport *a = Tables_us->Links->AutoReportForAnyKid;
if ( !a )				// no auto report for any kid
 return;
MakeAutoReports0(child, link, a);
}

////////////////////////////////////////////////////////////////////////////


void typeProto::FillAutoSignals()
{
register lexBMon *l = Tables_us->Lex;
register int s = l->TerminalsSize + l->LiteralsSize + l->NonTerminalsSize;
s = s/SZCHR + 1;			// size of bits
register char *b = AutoSignalBits;
if ( !b )
{
 b = new char[s];		        // get the bits
 AutoSignalBits = b;
}
while ( s-- )
 b[s] = 0;
register nodePointer *p = Parents;
while ( p )
{
 register autoSignal *as = p->AutoSignal;
 register brick state;
 if  ( as )
   while ( (state = as->AtState) != -1 )// for all signals for this link
   {
      SETBIT(b, state);
      as++;
   } 
 p = p->Link;				// next link
}
}

////////////////////////////////////////////////////////////////////////////

void typeProto::SendAutoSignals(register brick token, register void *atr)
{
register nodePointer *p = Parents;
while ( p )              			// for all parents
{
 register autoSignal *as = p->AutoSignal;
 register brick state;
 if ( as )
   while ( (state = as->AtState) != -1 )	// look for the token		
   {
      if ( token == state )			// auto signal to parent 
      {
          Local->Append()->Make0(p->ParentChild, this, as->Signal, atr);
	  break;
      }
      as++;
   }
 p = p->Link;
}
}


////////////////////////////////////////////////////////////////////////////

#ifdef __V10_COMPATIBILITY__
 char* CurrentNodeName;
#endif


brick typeProto::Parse(register typeProto **n)   // parse incoming messages
{

#ifdef __V10_COMPATIBILITY__
 CurrentNodeName = ObjectName;
#endif

*n = this; 
register mskxBMon *u = Tables_us;
register ubrick r;
if ( (r = u->Success(n, Stack, Error)) == u->Lex->Other ) // stack overflow?
 if ( Stack->Stack >= Stack->StackHigh )
   Stack->Stack--;
return r;
}


////////////////////////////////////////////////////////////////////////////

long typeProto::Verify()			// verify children
{
register nodePointer *c = Children;		// list of children
register links *l = Tables_us->Links;		// links
if ( !l )
 return 1;

register int co = l->Counter;			// number of fixed links

if ( !c )					// no children...
 if ( co )					// but must be - error
   return 0;
 else
   return 1;					// o'k - need not be
						// there are some children
if ( co )					// some fixed children
{
 register mskxBMon **flb = l->Links;		// array of fixed links
 register mskxBMon **fl = flb + co - 1;
 do						// check fixed children
 {
   if ( !c->ManyChildren && c->ParentChild )    // single child
   {
      if ( !c->IsFixed() || !c->DerivedFrom(*fl) ||// not fixed or not derived
	   (l->ExcLinks &&
	    HasException(l->ExcLinks[(int)(fl - l->Links)],
			c->ParentChild->Tables_us)) )
	  return 0;				// structure is corrupted
   }
   else                                         // many children
   {
      register nodePointer *cd = c;
      if ( (cd = cd->Down) != NULL )
      {
	  do
	       if ( !cd->IsFixed() || !cd->DerivedFrom(*fl) ||// not fixed
		    (l->ExcLinks &&                         // or not derived
		     HasException(l->ExcLinks[(int)(fl - l->Links)],
				  cd->ParentChild->Tables_us)) )
		     return 0;			// structure is corrupted
	  while ( (cd = cd->Link) != NULL );
      }
   }
   if ( (c = c->Link) == NULL )			// no more children
      if ( fl-- > flb )				// links remain
          return 0;				// structure is corrupted
      else					// no children, no links
          return 1;				// structure is o'k
 }
 while ( fl-- > flb );				// next link
}
						// check variable links
register mskxBMon *v = l->VLinks;		// list of variable links
if ( v )
{
 do						// check all children
   if ( c->IsFixed() || !c->DerivedFrom(v) || 	// not derived from v
        HasException(l->ExcVLink, c->ParentChild->Tables_us) )
      return 0;					// structure is corrupted
 while ( (c = c->Link) != NULL );
}
return 1;					// all children are valid
}


////////////////////////////////////////////////////////////////////////////

mskxBMon *typeProto::Verify(register nodePointer *p, register int n)// verify
{								    // links
register links *l = Tables_us->Links;		// links
register int co = l->Counter;			// number of fixed links

if ( n >= 0 && n < co )				// fixed link
 if ( !l->ExcLinks ||
      !HasException(l->ExcLinks[n], p->ParentChild->Tables_us) )
   return p->DerivedFrom(l->Links[n]);
if ( n >= co )                                  // variable link
 if ( !HasException(l->ExcVLink, p->ParentChild->Tables_us) )
   return p->DerivedFrom(l->VLinks);
return 0;					// negative n???
}


////////////////////////////////////////////////////////////////////////////

brick typeProto::Translate(register typeProto *d, register long m)//translate
{						// token m for type d
bml(MLEV) << "Translate this = <" << ObjectName << "> d = <" << d->ObjectName
          << "> m = <" << m << ">";
if ( this == d )
 return (brick)m;
register transTable *t = Trans;
register mskxBMon *u = d->Tables_us;
while ( t )
 if ( t->Relative == u )			// check the translation table
 {
   bml(MLEV) << "found t->ObjectName " << t->Relative->Name;
   return t->Table[(int)m];			// got it - translate...
 }
 else						// next table...
 {
   bml(MLEV) << "looking t->ObjectName " << t->Relative->Name;
   t = t->Link;
 }
Trans = new transTable(d, Trans, this);   	// create a new trans. table
m = d->Tables_us->Lex->Check((ubrick)m);	// verify m is in the range
return Trans->Table[(int)m];
}


////////////////////////////////////////////////////////////////////////////

void typeProto::Send(register long m)		// send to itself
{
register lexBMon *l = Tables_us->Lex;		// lex object for this node
m = l->Check(m);				// check if the token is valid
Local->InFront()->Make(this, this, m);		// send to itself
}


////////////////////////////////////////////////////////////////////////////

void typeProto::PostPone(register long l, register void *m)
{
Delay->Append()->PostPone(this, LastSender, l, m);//postpone in delay que
}


////////////////////////////////////////////////////////////////////////////

void typeProto::Send(register char *m)		// send to itself
{
Local->InFront()->Make(this, this, m);		// send to itself
}


////////////////////////////////////////////////////////////////////////////

void typeProto::Send()				// send to itself last token
{
Local->InFront()->Make0(this, this, LastSymbol,	// send to itself
				LastAttribute);
}


////////////////////////////////////////////////////////////////////////////

void typeProto::Send(register long l, register void *m)// send to itself
{
Local->InFront()->Make0(this, this, Tables_us->Lex->Check(l), m);
}


////////////////////////////////////////////////////////////////////////////

void typeProto::Send(register char *l, register void *m)// send to itself
{
Local->InFront()->Make0(this, this, Convert(l), m);
}


////////////////////////////////////////////////////////////////////////////

void typeProto::Send(register typeProto *d, register long m)	// send to d
{
if ( !d )
 return;
bml(MLEV) << "calling translate";
register lexBMon *l = Tables_us->Lex;		// lex object for this node
m = l->Check(m);				// check if the token is valid
Local->Append()->Make(d, this, Translate(d, m));// send translated token to d
}


////////////////////////////////////////////////////////////////////////////

void typeProto::Send(register typeProto *d, register char *m)	// send to d
{
if ( !d )
 return;
Local->Append()->Make(d, this, m);		// send token to d
}


////////////////////////////////////////////////////////////////////////////

void typeProto::Send(register typeProto *d)	// send to d last token
{
if ( !d )
 return;
Local->Append()->Make(d, this, LastSymbol,	// send to d
			    LastAttribute);
}


////////////////////////////////////////////////////////////////////////////

void typeProto::Send(register typeProto *d, register long l, // send to d
		     register void *m)
{
if ( !d )
 return;
Local->Append()->Make(d, this, l, m);		// send token to d
}


////////////////////////////////////////////////////////////////////////////

void typeProto::Send(register typeProto *d, register char *l, // send to d
		     register void *m)
{
if ( !d )
 return;
Local->Append()->Make(d, this, l, m);           // send token to d
}


////////////////////////////////////////////////////////////////////////////

void typeProto::SendBack(register long m)	// send back to the last sender
{
bml(MLEV) << "calling translate";
m = Tables_us->Lex->Check(m);			// check if message is valid
Local->Append()->Make(LastSender, this, Translate(LastSender, m));//send it back
}


////////////////////////////////////////////////////////////////////////////

void typeProto::SendBack(register char *m)	// send back to the last sender
{
Local->Append()->Make(LastSender, this, m);	//send it back...
}


////////////////////////////////////////////////////////////////////////////

void typeProto::SendBack()			// send back to the last sender
{						// the last token
Local->Append()->Make(LastSender, this, LastSymbol, //send it back...
				     LastAttribute);
}


////////////////////////////////////////////////////////////////////////////

void typeProto::SendBack(register long l, register void *m)// send back to the
{							   // last sender
Local->Append()->Make(LastSender, this, l, m);	//send it back...
}


////////////////////////////////////////////////////////////////////////////

void typeProto::SendBack(register char *l, register void *m)// send back to the
{							   // last sender
Local->Append()->Make(LastSender, this, l, m);   // send back
}


////////////////////////////////////////////////////////////////////////////

void typeProto::SendChildren(register long m,
			     register char *n)	// send to all children
{
m = Tables_us->Lex->Check(m);			// check if message is valid
linkIterator i(Children, n);		// for all children...
register nodePointer *c = i.Next();
while ( c )
{
 bml(MLEV) << "calling translate";
 register typeProto *d = c->ParentChild;	// get the child
 Local->Append()->Make(d, this, Translate(d, m));//send a message
 c = i.Next();					// next child
}
}


////////////////////////////////////////////////////////////////////////////

void typeProto::SendChildren(register char *m,
			     register char *n)	// send to all children
{
linkIterator i(Children, n);		// for all children...
register nodePointer *c = i.Next();
while ( c )
{
 register typeProto *d = c->ParentChild;	// get the child
 Local->Append()->Make(d, this, m);		// send a message
 c = i.Next();					// next child
}
}


////////////////////////////////////////////////////////////////////////////

void typeProto::SendChildren()	// send to all children last tokn
{
register char *n = 0;
register long m = LastSymbol;
register void *s = LastAttribute;
linkIterator i(Children, n);		// for all children...
register nodePointer *c = i.Next();
while ( c )
{
 register typeProto *d = c->ParentChild;	// get the child
 Local->Append()->Make(d, this, m, s);		// send a message
 c = i.Next();					// next child
}
}


////////////////////////////////////////////////////////////////////////////

void typeProto::SendChildren(register long l, register void *m,
			     register char *n)  // send to all children
{
linkIterator i(Children, n);		// for all children...
register nodePointer *c = i.Next();
while ( c )
{
 register typeProto *d = c->ParentChild;	// get the child
 Local->Append()->Make(d, this, l, m);		// send a message
 c = i.Next();					// next child
}
}


////////////////////////////////////////////////////////////////////////////

void typeProto::SendChildren(register char *l, register void *m,
			     register char *n)  // send to all children
{
linkIterator i(Children, n);		// for all children...
register nodePointer *c = i.Next();		// for all children...
while ( c )
{
 register typeProto *d = c->ParentChild;	// get the child
 Local->Append()->Make(d, this, l, m);		// send a message
 c = i.Next();					// next child
}
}
////////////////////////////////////////////////////////////////////////////

void typeProto::SendParents(register long m)	// send to all parents
{
m = Tables_us->Lex->Check(m);			// check if message is valid
register nodePointer *p = Parents;		// for all parents...
while ( p )
{
 bml(MLEV) << "calling translate";
 register typeProto *d = p->ParentChild;	// get the parent
 Local->Append()->Make(d, this, Translate(d, m));// send a message
 p = p->Link;					// next parent
}
}


////////////////////////////////////////////////////////////////////////////

void typeProto::SendParents(register char *m)	// send to all parents
{
register nodePointer *p = Parents;		// for all parents...
while ( p )
{
 register typeProto *d = p->ParentChild;	// get the parent
 Local->Append()->Make(d, this, m);		// send a message
 p = p->Link;					// next parent
}
}


////////////////////////////////////////////////////////////////////////////

void typeProto::SendParents()			// send to all parents last tok
{
register long m = LastSymbol;
register void *s = LastAttribute;
register nodePointer *p = Parents;		// for all parents...
while ( p )
{
 register typeProto *d = p->ParentChild;	// get the parent
 Local->Append()->Make(d, this, m, s);		// send a message
 p = p->Link;					// next parent
}
}


////////////////////////////////////////////////////////////////////////////

void typeProto::SendParents(register long l, register void *m)// send to all
{							      // parents
register nodePointer *p = Parents;		// for all parents...
while ( p )
{
 register typeProto *d = p->ParentChild;	// get the parent
 Local->Append()->Make(d, this, l, m);		// send a message
 p = p->Link;					// next parent
}
}


////////////////////////////////////////////////////////////////////////////

void typeProto::SendParents(register char *l, register void *m)// send to all
{							      // parents
register nodePointer *p = Parents;		// for all parents...
while ( p )
{
 register typeProto *d = p->ParentChild;	// get the parent
 Local->Append()->Make(d, this, l, m);		// send a message
 p = p->Link;					// next parent
}
}

////////////////////////////////////////////////////////////////////////////

void typeProto::SendBackFront(register long m)	// send back to the last sender
{
bml(MLEV) << "calling translate";
m = Tables_us->Lex->Check(m);			// check if message is valid
Local->InFront()->Make(LastSender, this, Translate(LastSender, m));//send it back
}


////////////////////////////////////////////////////////////////////////////

void typeProto::SendBackFront(register char *m)	// send back to the last sender
{
Local->InFront()->Make(LastSender, this, m);	//send it back...
}


////////////////////////////////////////////////////////////////////////////

void typeProto::SendBackFront()			// send back to the last sender
{						// the last token
Local->InFront()->Make(LastSender, this, LastSymbol, //send it back...
				     LastAttribute);
}


////////////////////////////////////////////////////////////////////////////

void typeProto::SendBackFront(register long l, register void *m)// send back to the
{							   // last sender
Local->InFront()->Make(LastSender, this, l, m);	//send it back...
}


////////////////////////////////////////////////////////////////////////////

void typeProto::SendBackFront(register char *l, register void *m)// send back to the
{							   // last sender
Local->InFront()->Make(LastSender, this, l, m);   // send back
}


////////////////////////////////////////////////////////////////////////////

void typeProto::SendChildrenFront(register long m,
				  register char *n)	// send to all children
{
m = Tables_us->Lex->Check(m);			// check if message is valid
linkIterator i(Children, n);		// for all children...
register nodePointer *c = i.Next();
while ( c )
{
 bml(MLEV) << "calling translate";
 register typeProto *d = c->ParentChild;	// get the child
 Local->InFront()->Make(d, this, Translate(d, m));// send a message
 c = i.Next();					// next child
}
}


////////////////////////////////////////////////////////////////////////////

void typeProto::SendChildrenFront(register char *m,
				  register char *n)	// send to all children
{
linkIterator i(Children, n);		// for all children...
register nodePointer *c = i.Next();
while ( c )
{
 register typeProto *d = c->ParentChild;	// get the child
 Local->InFront()->Make(d, this, m);		// send a message
 c = i.Next();					// next child
}
}


////////////////////////////////////////////////////////////////////////////

void typeProto::SendChildrenFront()// send to all last tokn
{
register char *n = 0;
register long m = LastSymbol;
register void *s = LastAttribute;
linkIterator i(Children, n);		// for all children...
register nodePointer *c = i.Next();
while ( c )
{
 register typeProto *d = c->ParentChild;	// get the child
 Local->InFront()->Make(d, this, m, s);		// send a message
 c = i.Next();					// next child
}
}


////////////////////////////////////////////////////////////////////////////

void typeProto::SendChildrenFront(register long l, register void *m,
				  register char *n)  // send to all children
{
linkIterator i(Children, n);		// for all children...
register nodePointer *c = i.Next();
while ( c )
{
 register typeProto *d = c->ParentChild;	// get the child
 Local->InFront()->Make(d, this, l, m);		// send a message
 c = i.Next();					// next child
}
}


////////////////////////////////////////////////////////////////////////////

void typeProto::SendChildrenFront(register char *l, register void *m,
				  register char *n)  // send to all children
{
linkIterator i(Children, n);		// for all children...
register nodePointer *c = i.Next();		// for all children...
while ( c )
{
 register typeProto *d = c->ParentChild;	// get the child
 Local->InFront()->Make(d, this, l, m);		// send a message
 c = i.Next();					// next child
}
}
////////////////////////////////////////////////////////////////////////////

void typeProto::SendParentsFront(register long m)// send to all parents
{
m = Tables_us->Lex->Check(m);			// check if message is valid
register nodePointer *p = Parents;		// for all parents...
while ( p )
{
 bml(MLEV) << "calling translate";
 register typeProto *d = p->ParentChild;	// get the parent
 Local->InFront()->Make(d, this, Translate(d, m));// send a message
 p = p->Link;					// next parent
}
}


////////////////////////////////////////////////////////////////////////////

void typeProto::SendParentsFront(register char *m)// send to all parents
{
register nodePointer *p = Parents;		// for all parents...
while ( p )
{
 register typeProto *d = p->ParentChild;	// get the parent
 Local->InFront()->Make(d, this, m);		// send a message
 p = p->Link;					// next parent
}
}


////////////////////////////////////////////////////////////////////////////

void typeProto::SendParentsFront()	    	// send to all parents last tok
{
register long m = LastSymbol;
register void *s = LastAttribute;
register nodePointer *p = Parents;		// for all parents...
while ( p )
{
 register typeProto *d = p->ParentChild;	// get the parent
 Local->InFront()->Make(d, this, m, s);		// send a message
 p = p->Link;					// next parent
}
}


////////////////////////////////////////////////////////////////////////////

void typeProto::SendParentsFront(register long l, register void *m)// send to all
{							      // parents
register nodePointer *p = Parents;		// for all parents...
while ( p )
{
 register typeProto *d = p->ParentChild;	// get the parent
 Local->InFront()->Make(d, this, l, m);		// send a message
 p = p->Link;					// next parent
}
}


////////////////////////////////////////////////////////////////////////////

void typeProto::SendParentsFront(register char *l, register void *m)// send to all
{							      // parents
register nodePointer *p = Parents;		// for all parents...
while ( p )
{
 register typeProto *d = p->ParentChild;	// get the parent
 Local->InFront()->Make(d, this, l, m);		// send a message
 p = p->Link;					// next parent
}
}


////////////////////////////////////////////////////////////////////////////

void transTable::Fill(register lexBMon *from,	// fill in translation table
		      register lexBMon *to)
{
register brick *t = Table;

register keyWord *b = from->Terminals;
register keyWord *e = b + from->TerminalsSize;
while ( b < e )
 t[b->Result] = to->FindToken(b->Word), b++;

b = from->Literals;
e = b + from->LiteralsSize;
while ( b < e )
 t[b->Result] = to->FindToken(b->Word), b++;

b = from->NonTerminals;
e = b + from->NonTerminalsSize;
while ( b < e )
 t[b->Result] = to->FindToken(b->Word), b++;
}


////////////////////////////////////////////////////////////////////////////

void childsAndParents::InitTransTable(register typeProto *t, 
				      register typeProto *n,
				      register nodePointer *r)
{
register transTable *tr = n->Tables_us->Node->Trans;
register mskxBMon *u = t->Tables_us;
while ( tr )
 if ( tr->Relative == u )		// table has been already created ?
 {
   r->Trans = tr;			// yes...
   return;
 }
 else
   tr = tr->Link;			// keep looking

 r->Trans = Trans = new transTable(t, Trans, n); // new table
}

////////////////////////////////////////////////////////////////////////////

long typeProto::Link(register typeProto *child, register char *name)
{ 
return Link(*child, name);
}

////////////////////////////////////////////////////////////////////////////

long typeProto::Link(register typeProto &child, register char *name)
{
char p[1024];

strcpy(p, child.ObjectName);
if ( name )
 strcat(p, ":"), strcat(p, name);
return LinkChildren(p, &child);
}

long typeProto::LinkChildren(char *a, typeProto *node)
{
char *nodeName = new char[strlen(a)+1], *linkName = new char[strlen(a)+1];
strcpy(nodeName, a);
register char *p = (char *)strchr(nodeName, ':');
if ( p )
{
 *p = 0;
 strcpy(linkName, p + 1);
}
else
{
 delete [] linkName;
 linkName = 0;
}

register int l = -1;
register nodePointer *c = Children;
if ( linkName )
 if ( Tables_us->Links->Counter )
 {
   while ( c )
   {
      l++;
      register char *cn = c->ChildName();
      if ( cn && !strcmp(cn, linkName) )
	  goto cont;
      c = c->Link;
   }
   l = -1;
   goto exit;
 }
 else
   goto exit;

cont:

if ( !node )                                  // get the node if not specified
 node = lookUpObjects(nodeName);

if ( !linkName && !Tables_us->Links->Counter )// variable link
{
 register mskxBMon *v = Tables_us->Links->VLinks;
 if ( v )                                    // variable links are specified
   if ( node->Tables_us->DerivedFrom(v) &&
	!HasException(Tables_us->Links->ExcVLink, node->Tables_us) )
   {                                         // type is o'k
       Address(node);                        // link it!
       MakeAutoReportsForAnyKid(node, node->Parents);
       node->FillAutoSignals();
       l = 0;
       goto exit;
   }
   else
       goto exit;
}
else
{                                            // fixed link
 register mskxBMon **u = Tables_us->Links->Links +
			 Tables_us->Links->Counter - l - 1;//fixed links

 register nodePointerFixed *f = (nodePointerFixed *)c;
 if ( c->IsFixed() )
 {                   		                // a fixed node
   if ( node->Tables_us->DerivedFrom(*u) &&
	(!Tables_us->Links->ExcLinks ||
	 !HasException(Tables_us->Links->ExcLinks[l],
		      node->Tables_us)) )       // derived o'k
      {
	  if ( c->ManyChildren )                // many children?
	  {
	       f = new nodePointerFixed(*(nodePointerFixed *)c);
	       f->Link = c->Down;
	       f->Down = 0;
	       f->ManyChildren = 0;
	       f->ParentChild = node;
	       c->Down = f;
	       c->ManyChildren++;
	  }
	  else
	       f = (nodePointerFixed *)c;
	  if ( *(f->ChildFixed) && !c->ManyChildren )
	       goto exit;
	  if ( !*(f->ChildFixed) && !c->ManyChildren )
	  {
	       *(f->ChildFixed) = node;
	       f->ParentChild = node;
	  }
	  Address0(node);
	  MakeAutoReports(node, node->Parents,
				Tables_us->Links->Counter - l - 1);
	  node->FillAutoSignals();
	  l = 0;
	  goto exit;
      }
 }
}
l = -1;

exit:

 delete [] linkName;
 delete [] nodeName;
 return l;
}

////////////////////////////////////////////////////////////////////////////

long typeProto::UnLinkChildren(register typeProto *node)
{
return UnLink(node, 0);
}

////////////////////////////////////////////////////////////////////////////

long typeProto::UnLink(register typeProto *node, register char *name)
{
 register nodePointer **ca = &Children;          // prepare to loop
 register nodePointer *c = Children;
 if ( name )					 // fixed link
 {
  while ( c )                                    // for all children
  {
    register nodePointer *c0 = c;                // top link
    register nodePointer *cp = c;                // previous link
    register char *cn = c->ChildName();
    if ( cn && !strcmp(cn, name) )
    {
       if ( c->ManyChildren )
       {
	   c = c->Down;
	   while ( c )
	   {
		if ( c->ParentChild == node )    // found the link
		      goto cont;
		cp = c;
		c = c->Link;
	   }
	   goto exit;
cont:
	   if ( cp == c0 )         	         // get out of the list
		c0->Down = (nodePointerFixed *)(c->Link);
	   else
		cp->Link = c->Link;
	   c0->ManyChildren--;
	   c->ParentChild->UnLinkParent(this);   // unlink parent this from c
	   delete c;
       }
       else if ( c->ParentChild )
       {
	   c->ParentChild->UnLinkParent(this);   // unlink parent this from c
	   c->ClearFixed();
       }
       return 0;                                 // job done...
    }
    ca = &(c->Link);                             // next node
    c = c->Link;
  }
 }
 else
 {
  while ( c )                                    // for all children
  {
    if ( c->ParentChild == node )
    {
           c->ParentChild->UnLinkParent(this);   // unlink parent this from c
	   *ca = c->Link;                        // yes, unlink it
	   delete c;                             // then delete
	   return 0;                             // job done...
    }
    ca = &(c->Link);                             // next node
    c = c->Link;
  }
 }

exit:

 cerr << "\nS3: no such child <" << node->ObjectName << '>' << endl;
 return 1;
}

////////////////////////////////////////////////////////////////////////////

void typeProto::UnLinkParent(register typeProto *n)
{
register nodePointer **pa = &Parents;
register nodePointer *p = Parents;
while ( p )
{
 if ( p->ParentChild == n )
 {
   *pa = p->Link;
   delete p;
   p = *pa;
 }
 else
 {
   pa = &(p->Link);
   p = p->Link;
 }
}
}

////////////////////////////////////////////////////////////////////////////

extern bmNode *allNodes;

typeProto *typeProto::Add(register char *tnm, register char *nm)
{
register typeProto *n = New();                  // new node
n->Bring(tnm, nm);
return n;
}

void typeProto::Bring(register char *tnm, register char *nm)
{
#ifdef __V10_COMPATIBILITY__
NodeFlags |= DynamicNode;			// this is a dynamic node
#else
Flags |= DynamicNode;			        // this is a dynamic node
#endif
Children = 0;
Parents = 0;
ObjectName = nm;
TablesName_us = tnm;
Address();                                      // init parsing tables
AllFixedLinks();                                // create fixed links (if any)

#ifndef __V10_COMPATIBILITY__
 allNodes = new bmNode(this, allNodes);
#else
 register bmNodes *cn = currentNodeLib;         // put on the list of nodes
 cn->Link = new bmNode(cn, this, cn->Link);
 cn->Current = cn->Link;
#endif

}

////////////////////////////////////////////////////////////////////////////

void typeProto::Delete()
{
#ifdef __V10_COMPATIBILITY__
if ( NodeFlags&DynamicNode )
#else
if ( Flags&DynamicNode )
#endif
 Delete(this);
}


////////////////////////////////////////////////////////////////////////////

void typeProto::Delete(register typeProto *n)
{

#ifndef __V10_COMPATIBILITY__
register bmNode *prev = allNodes;
register bmNode *bmn = allNodes;
while ( bmn )
{
 if (bmn->Node == n)
 {
   if ( bmn->Link )
      prev->Link = bmn->Link;
   else
      prev->Link = 0;
   // free the node
   delete n;
   delete bmn;
   break;
 }
 prev = bmn;
 bmn = bmn->Link;
}
#else
	 register bmNodes *lib = allNodeLib;
	 while ( lib ) {
		 register bmNode *prev = (bmNode *)lib;
		 register bmNode *bmn = lib->Link;
		 while ( bmn ) {
			 if (bmn->Node == n) {
				 if ( bmn->Link )
					 prev->Link = bmn->Link;
				 else
					 prev->Link = 0;
				 // free the node
				 delete n;
				 delete bmn;
				 break;
			 }
			 prev = bmn;
			 bmn = bmn->Link;
		 }
		 lib = lib->Next;
	 }
#endif

}


////////////////////////////////////////////////////////////////////////////

void typeProto::Copy(register sAtribus &nm)
{
(void)(Tables_us->Node->Add(TablesName_us, nm.Word));
}

////////////////////////////////////////////////////////////////////////////

typeProto *typeProto::Copy(register char *nm)
{
return Tables_us->Node->Add(TablesName_us, nm);
}

////////////////////////////////////////////////////////////////////////////

typeProto *typeProto::Clone(register char *nm)
{
return Tables_us->Node->Add(TablesName_us, nm);
}

////////////////////////////////////////////////////////////////////////////

int typeProto::Modify(register char *, register char *)
{
return 0;
}

////////////////////////////////////////////////////////////////////////////

long typeProto::TopStack(register long p)	// get the stack element
{
if ( p == -1 )
 return Stack->Stack - Stack->StackLimit;       // stack depth
register stackElement *s = Stack->Stack - (int)p;
if ( s < Stack->StackLimit )
 return -1;   				        // too deep
else
 return Tables_us->Lr1Tables->DebugHash[Stack->GetSave(s)]->Result;
}

////////////////////////////////////////////////////////////////////////////

char *typeProto::TopStackSymbol(register long p) // get the stack element
{
if ( p < 0 )
 return 0;
register stackElement *s = Stack->Stack - (int)p;
if ( s < Stack->StackLimit )
 return 0;   				         // too deep
else
 return Tables_us->Lr1Tables->DebugHash[Stack->GetSave(s)]->Word;
}

////////////////////////////////////////////////////////////////////////////

long typeProto::AllChildrenState(register long state,// all children in state?
			    register char *n)   // possible link name
{
linkIterator i(Children, n);		// for all children...
register nodePointer *c = i.Next();
register long ret = 1;
if ( !c )
 ret = 0;
else
 do
   if ( !(c->ParentChild) ||
	c->ParentChild->CurrentState != Translate(c->ParentChild, state) )
   {
      ret = 0;
      break;
   }
 while ( (c = i.Next()) != NULL );
return ret;
}

////////////////////////////////////////////////////////////////////////////

long typeProto::AnyChildState(register long state,  // any child in state?
			 register char *n)     // possible link name
{
linkIterator i(Children, n);	       // for all children...
register nodePointer *c = i.Next();
register long ret = 0;
if ( !c )
 ret = 0;
else
 do
   if ( c->ParentChild &&
	c->ParentChild->CurrentState == Translate(c->ParentChild, state) )
   {
      ret = 1;
      break;
   }
 while ( (c = i.Next()) != NULL );
return ret;
}

////////////////////////////////////////////////////////////////////////////

initStaticTypes::initStaticTypes(register typeDescriptorBMon *t)
{
Link = typeList;
typeList = this;
Types = t;
}

////////////////////////////////////////////////////////////////////////////

initStaticNodes::initStaticNodes(register typeProto **n, register void (*i)())
{
i();
Link = nodeList;
nodeList = this;
Nodes = n;
}


linkIterator::linkIterator(register nodePointer *c, register char *n)
{
Current = 0;
CurrentDown = 0;
Name = n;
while ( c )
{
 Current = c;
 register char *cn = c->ChildName();
 if ( !c->ManyChildren )
 {
   CurrentDown = 0;
   if ( !n )
      break;
   if ( cn && !strcmp(cn, n) )
      break;
   c = c->Link;
 }
 else
 {
   CurrentDown = c->Down;
   if ( !n )
   {
     if ( !CurrentDown )
     {
	 c = c->Link;
	 continue;
     }
     break;
   }
   if ( cn && !strcmp(cn, n) )
     break;
   c = c->Link;
 }
}
}

nodePointer *linkIterator::Next()
{
register nodePointer *ret;

if ( CurrentDown )
{
  ret = CurrentDown;
  CurrentDown = CurrentDown->Link;
}
else
{
 if ( Name )
   ret = 0;
 else
 {
  for ( ;; )
  {
      if ( !Current || !Current->ManyChildren )
      {
	   ret = Current;
	   if ( Current )
		 Current = Current->Link;
	   break;
      }
      else
      {
	   CurrentDown = Current->Down;
	   Current = Current->Link;
	   if ( CurrentDown )
	   {
		ret = CurrentDown;
		CurrentDown = ret->Link;
		break;
	   }
      }
   }
 }
}
return ret;
}

mskxBMon::mskxBMon(register lr1TablesBMon *lr1, register lexBMon *l,
		   register typeProto *n, register links *ln,
		   register baseTypes *b, register char *nm, register int s)
{
Lr1Tables = lr1;
Lex       = l;
Node      = n;
if ( n )
{
 register char *c = new char [strlen(nm) + 6];
 strcpy(c, "mskx_");
 strcat(c, nm);
 n->TablesName_us = c;
 n->Tables_us = this;
}
Links     = ln;
BaseTypes = b;
Name      = nm;
MaxTokens = s;
}


#ifdef __V10_COMPATIBILITY__
typeProto::~typeProto(void)
{ delete [] AutoSignalBits; delete Delay; }

initStaticNodes *nodeList;

#endif


//
// Definition of various member (virtual) functions
//
////////////////////////////////////////////////////////////////////////////////

nodePointer::~nodePointer()                   { delete [] AutoSignal; }
nodePointer *nodePointer::ClearFixed()        { return 0; }
char        *nodePointer::ChildName ()        { return 0; }
typeProto  **nodePointer::IsFixed()           { return 0; }

char        *nodePointerFixed::ChildName()    { return ChildArgName; }
nodePointer *nodePointerFixed::ClearFixed()
{
*ChildFixed = 0; ParentChild = 0; return this;
}
typeProto  **nodePointerFixed::IsFixed()      { return ChildFixed; }

void   typeProto::SetSelf()                   {}
brick  typeProto::Action0(ubrick, stack *)    {return 0;}
brick  typeProto::ActionSkip0(ubrick)         {return 0;}
rule  *typeProto::ActionN(ubrick, stack *)    {return 0;}
rule  *typeProto::ActionO(ubrick, stack *)    {return 0;}
rule  *typeProto::ActionSkipN(ubrick)         {return 0;}
void   typeProto::Init()                      {}
void   typeProto::Resolve()                   {}
typeProto *typeProto::New()                   {return 0;}
void   typeProto::AllFixedLinks()             {}
void   typeProto::SetState(register ubrick s) { CurrentState = s; }
ubrick typeProto::GetCurrentState()           { return (ubrick)CurrentState; }

brick typeProto::UserLexBMon(tokenBMon *, void *)
{
return Tables_us->Lex->Other;
}

void typeProto::Print(register ostream &o)
{
o << "\n\nObject name <" << ObjectName << '>';
o << "\nType of object <" << TablesName_us << '>';
o << "\nLastSender <";
LastSender->Print(o);
o << '>';
o << "\nLastSymbol <" << LastSymbol << '>';
}

void  typeProto::PrintName()
{
(*(Tables_us->Lr1Tables->Cerr)) << " object - " << ObjectName;
}

#ifndef __V10_COMPATIBILITY__
typeProto *typeProto::GetBasic() { return this; };
#endif

void  typeProto::ExecuteTrigger(ubrick, stack *) {}   // execute a trigger
void  typeProto::ExecuteReductor(stack *, ubrick) {}  // execute a reductor

long typeProto::Generate(register long length, register long number,
			 register ostream &o)
{
(void)Tables_us->Lr1Tables->Generate(Lex, length, number, o);

/*
cout << "\n////////////////////////";

Tables_us->Lr1Tables->Generator->Flag |= F_messages;
(void)Tables_us->Lr1Tables->Generate(Lex, length, number, o);

*/

return 0;
}

