/////////////////////////////////////////////////////////////
//                                                         //
// Copyright 1994, 1995, 1996                              //
// MASTER INFORMATION SYSTEMS CORPORATION                  //
// MUSKOX Version 1.2					   //
// All Rights Reserved                                     //
//                                                         //
/////////////////////////////////////////////////////////////


#ifndef __bml_h_
#define __bml_h_

/******************************************************************_COMMENT

The file contains macros to debug the standard framework.

		bml()

Macro bml() prints out debugging information at run-time in various places of 
the standard framework. The arguments to bml() macro are defined 
below. They are equal to 2^N where N is a flag to specify on 
the command line when running the standard framework. The specified
values are stored in bmLogLevel.

		bmLog

The bml() printout goes to ofstream *bmLog, which is initialized to armName.log
in the source file pc.cpp. The printout includes 
file name, line number of the macro invocation, and any other 
information specified for a macro call.  

INVOCATION
----------
To print out expressions x, y, z, etc. when level LEV is
specified on the command line, invoke bml() macro as

		bml(LEV) << x << y << z ...;

COMMENT_******************************************************************/


#ifdef unix
#include <sys/types.h>
#endif

#include <time.h>

extern ofstream *bmLog;			// log stream
extern int bmLogLevel;			// log levels, set in main()

					//
					// bml() macro
					//

#define bml(N)  if ( (1 << N) & bmLogLevel ) \
				(*bmLog) << "\n  " << N << ':' << \
				__FILE__ << ':' << __LINE__ << ": "

					//
					// bml() macro arguments
					//
#define BMLEV  2                      	/* main() level */
#define MLEV   4                      	/* framework level */
#define TLEV   8                      	/* symbol level */
#define QLEV  10                      	/* local queue level */

#endif
