/////////////////////////////////////////////////////////////
//                                                         //
// Copyright 1994, 1995, 1996                              //
// MASTER INFORMATION SYSTEMS CORPORATION                  //
// MUSKOX Version 1.2					   //
// All Rights Reserved                                     //
//                                                         //
/////////////////////////////////////////////////////////////


#ifndef __inpus_h_
#define __inpus_h_

#include <iostream.h>

#ifndef __atribus_h_
# include "atribus.h"
#endif

/******************************************************************_COMMENT

This file contains definition of the inpus class. This class is used 
in the stand alone State Transition Engine (Success and SuccessInRealTime
from lr1Tables). You use inpus class when you want to accept names of 
messages and states from the input stream in the default lexer.
You have to define INPUS constant for input class to be declared.

Class input maintains a list of char buffers where it stores the symbols 
scanned from cin.

COMMENT_******************************************************************/

#ifdef INPUS
				//
				// class input maintains a list of
				// char buffers where it stores the symbols
				// scanned from cin.
				//
class	input
	{
public:
	char    Inp;		// next input symbol
	char   *Next;		// next available position for
				// next symbol
	char   *Limit;		// current limit to store
	char   *Last;		// address of the last extension piece
	int	Extend;		// extension size
	long    Line;		// input file line number
		input(int, int);	// constructor
	char   *ExtendInput(char *);    // extend input table
	void	IncreaseInput(int);  	// increase input table
	void	FreeInput();		// release input buffers
	void	ErrMessage(char *);	// error message
	void    SkipLine();		// skip current line
	char    GetSym()                // get next symbol
		{
		 register int sym = cin.get();
		 if ( sym == EOF )
		  sym = 0;
		 else if ( sym == '\n' )
		  Line++;
		 Inp = (char)sym;       // store current symbol
		 return sym;            // and return it ...
		}
	char	*GetName();		// get name
	void	SkipComment();		// skip comment
	char	*GetNumber();		// get number
	void	Store();		// stores Inp in the buffer
	};
#else
struct input		// if INPUS is not defined, then we do not
{			// use input, so this definition just declares
	void	*Input;	// a (useless) name
};
#endif

#endif
