/////////////////////////////////////////////////////////////
//                                                         //
// Copyright 1994, 1995, 1996                              //
// MASTER INFORMATION SYSTEMS CORPORATION                  //
// MUSKOX Version 1.2					   //
// All Rights Reserved                                     //
//                                                         //
/////////////////////////////////////////////////////////////


#ifndef __skelbmon_h_
#define __skelbmon_h_

#ifndef __atribus_h_
#include "atribus.h"
#endif

#ifndef __inpus_h_
#include "inpus.h"
#endif

#ifndef __skeletus_h_
#include "skeletus.h"
#endif


/******************************************************************_COMMENT

This file defines data structures for the Standard Framework and the
State Transition Engine:

lexBMon				a derived class from lex -- defines a 
				lexical analyzer for the Standard
				Framework. Generated by the MUSKOX compiler
				for each type.

errorBMon			a derived class from error -- defines an
				error object for the Standard Base Framework.
				Generated by the MUSKOX compiler for each type.

lr1TablesBMon			a derived class from lr1Tables -- defines
				parsing tables and the State Transition Engine
				for the Standard Base Framework. The member-
				function ParseBMon() is the State Transition
				Engine. Generated by the MUSKOX compiler for
				each type.

mskxBMon			this class is the main handle to the
				data associated with a MUSKOX type. For each
				type MUSKOX compiler generates an instance of 
				mskxBMon. 

autoReport 			this struct defines which symbol (Report) 
				should be sent when an object shifts a symbol 
				defined in the state State. Used for the 
				automatic state change notification with 
				marked symbols. Generated by the MUSKOX
				compiler for marked symbols of every type.

links				defines the data associated with the
				links of the type. Generated by the MUSKOX
				compiler for every type.

baseTypes			a handle to the array of linked types. Generated
				by the MUSKOX compiler for every type.

Report				a macro that sends Yes or No the object
				itself depending on the result of the condition.

mskxBits			a number of macros that manipulate with bits.

					SZCHR   -- size of character
					SETBIT  -- setx a bit
					BIT     -- tests a bit

COMMENT_******************************************************************/

#ifndef __V10_COMPATIBILITY__
# ifndef BMON
#   define BMON
# endif
#endif

class typeProto;

//
// lexBMon
//
//////////////////////////////////////////////////////////////////////////
class	lexBMon : public lex		// lexical analyzer for engine
{
public:
	ubrick	Size;		// number of terminals, literals, nonterminals
        lexBMon(register keyWord *lit,  register ubrick litSize,
		register keyWord *term, register ubrick termSize,
                register keyWord *non,  register ubrick nonSize,
                register ubrick endOfStream, register ubrick other,
		register keyWord *key,  register input *inp,
                register void (lex::*set)()) : lex(lit, litSize, term, termSize,
						   non, nonSize, endOfStream,
						   other, key, inp, set)
		{ Size = termSize + litSize + nonSize; }
virtual ubrick LexBMon(void *, typeProto **, typeProto *);
	ubrick Check(register long m) { return (ubrick)((m >= 0 && (ubrick)m < Size)?m:Other); }
	ubrick FindToken(register char *);		 
};
//////////////////////////////////////////////////////////////////////////


class lr1TablesBMon;

//
// errorBMon
//
//////////////////////////////////////////////////////////////////////////
class	errorBMon : public error		// error object for engine
{
public:
	errorBMon(register int s = 100) : error(s) {}
virtual int  RecoverBMon(lr1TablesBMon *, stack *, lexBMon *, 
			 typeProto **, ubrick *, void *);
};
//////////////////////////////////////////////////////////////////////////


//
// lr1Tables
//
//////////////////////////////////////////////////////////////////////////
class	lr1TablesBMon : public lr1Tables	// parsing tables for the engine
{
public:
	lr1TablesBMon(register char   *name,
		      register ubrick *reduceHash,
                      register keyWord **debugHash,
                      register ubrick *reduce1,
		      register ubrick *reduce2Table,
                      register ubrick *shiftHash,
                      register ubrick *out1,
                      register ubrick *out2,
                      register ubrick *out3,
                      register ubrick *out4,
                      register ubrick *rows,
		      register ubrick *tran,
                      register packIt *tokens,
                      register ubrick   endOfStream,
                      register ubrick   err,
		      register ubrick   trig,
		      register ubrick   reduc,
                      register ubrick   accept,
                      register ubrick   start,
                      register ubrick   dummy,
                      register ubrick  startState,
		      register brick   init,
		      register brick   errorMessage,
                      register stack   *s,
                      register lex    *l,
                      register error  *errorProc,
		      register generator *g) : lr1Tables(name,
							 reduceHash,
                  					 debugHash, 
                  					 reduce1, 
							 reduce2Table,
                  					 shiftHash, 
							 out1,
                  					 out2, 
							 out3, 
							 out4,
							 rows,
                  			                 tran, 
							 tokens, 
							 endOfStream,
                  					 err, 
							 trig,
							 reduc,
							 accept, 
							 start,
							 dummy,
                  					 startState, 
							 init, 
							 errorMessage,
							 s,
							 l,
                  					 errorProc, 
							 g) {}
brick  ParseBMon(stack *, lexBMon *, errorBMon *, typeProto **);
};
//////////////////////////////////////////////////////////////////////////


class links;
class baseTypes;

//
// mskxBMon
//
//////////////////////////////////////////////////////////////////////////
class	mskxBMon			// a handle to a type
{
public:
	lr1TablesBMon *Lr1Tables;	// parsing tables
        lexBMon       *Lex;		// lexical analyzer
        typeProto     *Node;		// exemplar object
	links	      *Links;		// links of the type
	baseTypes     *BaseTypes;	// list of base types
	char	      *Name;		// type name
	int	       MaxTokens;	// number of type's symbols
	mskxBMon(register lr1TablesBMon *lr1, register lexBMon *l,
                 register typeProto *n, register links *ln,
		 register baseTypes *b, register char *nm, register int s);
	
virtual brick Success(typeProto **, stack *, errorBMon *);
	mskxBMon *DerivedFrom(mskxBMon *);
};
//////////////////////////////////////////////////////////////////////////

//
// autoReport
//
//////////////////////////////////////////////////////////////////////////
struct autoReport			// automatic message report
{
	ubrick Report;			// report this message automatically
	char  *State;			// at this state
};
//////////////////////////////////////////////////////////////////////////

//
// links
//
//////////////////////////////////////////////////////////////////////////
class	links				// array of links for type
{
public:
	int          Counter;		// number of fixed links
	mskxBMon   **Links;		// fixed links to descendants
	mskxBMon    *VLinks;		// variable link
        mskxBMon  ***ExcLinks;          // fixed links exceptions
        mskxBMon   **ExcVLink;          // variable link except_
	autoReport **AutoReportForKid;  // auto state reports
	autoReport  *AutoReportForAnyKid;// auto state reports for any kid
	autoReport  *AutoReportForAnyDad;// auto state reports for any dad
	links(register int c, register mskxBMon **l, register mskxBMon *v,
	      register mskxBMon ***e, register mskxBMon **ev,
	      register autoReport **a, register autoReport *ak,
	      register autoReport *ad)
	{ Counter = c, Links = l, VLinks = v; 
	  ExcLinks = e; ExcVLink = ev; AutoReportForKid = a;
	  AutoReportForAnyKid = ak; AutoReportForAnyDad = ad; }
};
//////////////////////////////////////////////////////////////////////////

//
// baseTypes
//
//////////////////////////////////////////////////////////////////////////
class	baseTypes			// list of base types
{
public:
	int        Counter;		// number of base types
	mskxBMon **Bases;		// array of base types
	baseTypes(register int c, register mskxBMon **b)
	{ Counter = c, Bases = b; }
};
//////////////////////////////////////////////////////////////////////////

//
// Report
//
//////////////////////////////////////////////////////////////////////////
#define Report(condition) Send((condition)?Yes:No)
//////////////////////////////////////////////////////////////////////////

//
// mskxBits
//
//////////////////////////////////////////////////////////////////////////
extern unsigned char mskxBits[8];
#define SZCHR sizeof(unsigned char)
#define SETBIT(a, n) (a[n/SZCHR] |= mskxBits[n%SZCHR])
#define BIT(a, n) ((a) && (a[n/SZCHR]&mskxBits[n%SZCHR]))
//////////////////////////////////////////////////////////////////////////

#endif
